	.file	"TiPLC.c"
.data
tigcc_compiled.:
#APP
/* Main Startup Code */
	.even
	/* Screen Saving Support */
	lea (%sp,-3840),%sp
	pea 3840
	pea 0x4C00
	pea (%sp,8)
	move.l 0xC8,%a0
	move.l (%a0,0x26A*4),%a2
	jsr (%a2) /* memcpy */
	/* exit and atexit fix */
	jbsr _main
	/* Screen Saving Support (Restoring) */
	pea 3840
	pea (%sp,16)
	pea 0x4C00
	jsr (%a2)
	lea (%sp,3864),%sp
	rts
	.even
#NO_APP
#APP
	/* Include Patch: nostub */
	/* Include Patch: nostub_optimize_rom_calls */
	/* Include Patch: nostub_save_screen */
	/* Include Patch: no_retval */
	/* Include Patch: exit_support */
	/* Include Patch: complex_main */
	.set MT_TEXT,0x8000
	.set MT_XREF,0x9000
	.set MT_ICON,0xA000
	.set MT_CASCADE,0x4000
#NO_APP
.globl pLinkPort
.data
	.even
pLinkPort:
	.long 6291470
.globl pLinkStatus
	.even
pLinkStatus:
	.long 6291468
.globl iOldPortStatus
	.even
iOldPortStatus:
	.word 0
.globl BitPeriod1
	.even
BitPeriod1:
	.word 0
.globl BitPeriod1Tx
	.even
BitPeriod1Tx:
	.word 0
.globl BitPeriod15
	.even
BitPeriod15:
	.word 0
.globl SerialDataRx
SerialDataRx:
	.byte 0
.globl BaudRateBreakPoints
	.even
BaudRateBreakPoints:
	.word 110
	.word 300
	.word 1200
	.word 2400
	.word 4800
	.word 9600
	.word 19200
	.word 38400
	.word 57600
.globl BaudRateIndex
	.even
BaudRateIndex:
	.word 5
.data
	.even
.globl SetBaudRate
SetBaudRate:
	link.w %a6,#0
	move.w BaudRateIndex,%d0
	cmp.w #8,%d0
	jbhi .L3
	and.l #0xFFFF,%d0
	add.l %d0,%d0
	.set .LI13,.+2
	move.w .L13-.LI13.b(%pc,%d0.l),%d0
	jmp %pc@(2,%d0:w)
	.even
.L13:
	.word .L4-.L13
	.word .L5-.L13
	.word .L6-.L13
	.word .L7-.L13
	.word .L8-.L13
	.word .L9-.L13
	.word .L10-.L13
	.word .L11-.L13
	.word .L12-.L13
	.even
.L4:
	move.w #11658,BitPeriod1
	move.w #17475,BitPeriod15
	move.w #11658,BitPeriod1Tx
	jbra .L3
	.even
.L5:
	move.w #4259,BitPeriod1
	move.w #6397,BitPeriod15
	move.w #4259,BitPeriod1Tx
	jbra .L3
	.even
.L6:
	move.w #1048,BitPeriod1
	move.w #1577,BitPeriod15
	move.w #1048,BitPeriod1Tx
	jbra .L3
	.even
.L7:
	move.w #515,BitPeriod1
	move.w #778,BitPeriod15
	move.w #515,BitPeriod1Tx
	jbra .L3
	.even
.L8:
	move.w #247,BitPeriod1
	move.w #362,BitPeriod15
	move.w #247,BitPeriod1Tx
	jbra .L3
	.even
.L9:
	move.w #113,BitPeriod1
	move.w #162,BitPeriod15
	move.w #113,BitPeriod1Tx
	jbra .L3
	.even
.L10:
	move.w #46,BitPeriod1
	move.w #76,BitPeriod15
	move.w #44,BitPeriod1Tx
	jbra .L3
	.even
.L11:
	move.w #13,BitPeriod1
	move.w #27,BitPeriod15
	move.w #11,BitPeriod1Tx
	jbra .L3
	.even
.L12:
	move.w #2,BitPeriod1
	move.w #10,BitPeriod15
	clr.w BitPeriod1Tx
.L3:
	unlk %a6
	rts
	.even
.globl GetByte
GetByte:
	link.w %a6,#0
	movm.l #0x1820,-(%sp)
	move.l 8(%a6),%a2
	clr.b %d4
	move.l %a2,%d3
	move.w #1792,-(%sp)
	move.l 2672(%a5),%a0
	jsr (%a0)
	move.l pLinkPort,%a0
	move.w #512,(%a0)
	addq.l #2,%sp
	tst.l %d3
	jbne .L31
	.even
.L19:
	move.l pLinkPort,%a0
	move.w (%a0),%d0
	btst #10,%d0
	jbne .L18
	move.w BitPeriod15,-(%sp)
	lea DoDelay,%a2
	jsr (%a2)
	clr.w %d3
	addq.l #2,%sp
	.even
.L25:
	move.l pLinkPort,%a0
	move.w (%a0),%d0
	btst #10,%d0
	jbeq .L26
	moveq.l #1,%d0
	lsl.w %d3,%d0
	or.b %d0,%d4
.L26:
	move.w BitPeriod1,-(%sp)
	jsr (%a2)
	addq.l #2,%sp
	addq.w #1,%d3
	cmp.w #7,%d3
	jbls .L25
	move.b %d4,SerialDataRx
	clr.w -(%sp)
	move.l 2672(%a5),%a0
	jsr (%a0)
	moveq.l #1,%d0
	jbra .L29
	.even
.L18:
	cmp.w #0,%a2
	jbeq .L19
.L31:
	subq.l #1,%d3
	jbne .L19
	clr.w -(%sp)
	move.l 2672(%a5),%a0
	jsr (%a0)
	clr.w %d0
.L29:
	movm.l -12(%a6),#0x418
	unlk %a6
	rts
	.even
.globl SendByte
SendByte:
	link.w %a6,#0
	movm.l #0x1820,-(%sp)
	move.b 9(%a6),%d4
	move.w #1792,-(%sp)
	move.l 2672(%a5),%a0
	jsr (%a0)
	move.l pLinkPort,%a0
	move.w #512,(%a0)
	move.l pLinkPort,%a0
	move.w #0,(%a0)
	move.w BitPeriod1Tx,-(%sp)
	lea DoDelay,%a2
	jsr (%a2)
	clr.w %d3
	addq.l #4,%sp
	.even
.L36:
	clr.w %d0
	move.b %d4,%d0
	asr.w %d3,%d0
	btst #0,%d0
	jbeq .L37
	move.l pLinkPort,%a0
	move.w #512,(%a0)
	jbra .L38
	.even
.L37:
	move.l pLinkPort,%a0
	move.w #0,(%a0)
.L38:
	move.w BitPeriod1Tx,-(%sp)
	jsr (%a2)
	addq.l #2,%sp
	addq.w #1,%d3
	cmp.w #7,%d3
	jbls .L36
	move.l pLinkPort,%a0
	move.w #512,(%a0)
	move.w BitPeriod1Tx,-(%sp)
	jsr (%a2)
	clr.w -(%sp)
	move.l 2672(%a5),%a0
	jsr (%a0)
	movm.l -12(%a6),#0x418
	unlk %a6
	rts
	.even
.globl DoDelay
DoDelay:
	link.w %a6,#0
	move.w 8(%a6),%d0
	subq.w #1,%d0
	cmp.w #65535,%d0
	jbeq .L40
	.even
.L43:
	dbra %d0,.L43
.L40:
	unlk %a6
	rts
	.even
.globl OpenLinkPort
OpenLinkPort:
	link.w %a6,#0
	move.l pLinkStatus,%a0
	move.w (%a0),iOldPortStatus
	move.w #-256,(%a0)
	unlk %a6
	rts
	.even
.globl CloseLinkPort
CloseLinkPort:
	link.w %a6,#0
	move.l pLinkPort,%a0
	move.w #0,(%a0)
	move.l pLinkStatus,%a0
	move.w iOldPortStatus,(%a0)
	unlk %a6
	rts
.globl symbolName
.data
	.even
symbolName:
	.long .LC0
	.long .LC1
	.long .LC2
	.long .LC3
	.long .LC4
	.long .LC5
	.long .LC6
	.long .LC7
	.long .LC8
	.long .LC9
	.long .LC10
.data
.LC10:
	.ascii "LBL\0"
.LC9:
	.ascii "JMP\0"
.LC8:
	.ascii "RES\0"
.LC7:
	.ascii "TMR\0"
.LC6:
	.ascii "CNT\0"
.LC5:
	.ascii "OSR\0"
.LC4:
	.ascii "OTU\0"
.LC3:
	.ascii "OTL\0"
.LC2:
	.ascii "OTE\0"
.LC1:
	.ascii "XIO\0"
.LC0:
	.ascii "XIC\0"
.globl entries
.data
	.even
entries:
	.word 0
.globl x
	.even
x:
	.word 0
.globl y
	.even
y:
	.word 0
.globl winOffset
	.even
winOffset:
	.word 0
.globl watch
	.even
watch:
	.word 0
	.word 0
	.word 0
	.word 0
.globl watchIndex
watchIndex:
	.byte 0
	.byte 1
	.byte 0
	.byte 1
.globl toolOffset
	.even
toolOffset:
	.word 0
.globl refreshMenu
	.even
refreshMenu:
	.word 0
.globl tools
	.even
tools:
	.long .LC11+6
	.long .LC12+8
	.long .LC13+5
	.long .LC14+5
	.long .LC15+5
	.long .LC16+7
	.long .LC17+4
	.long .LC18+4
	.long .LC19+4
	.long .LC20+4
	.long .LC21+4
	.long .LC22+4
	.long .LC23+4
	.long .LC24+8
	.long .LC25+6
	.long .LC26+6
	.long .LC27+4
	.long .LC28+6
.data
.LC28:
	.ascii "\0label\0"
.LC27:
	.ascii "\0jmp\0"
.LC26:
	.ascii "\0reset\0"
.LC25:
	.ascii "\0timer\0"
.LC24:
	.ascii "\0counter\0"
.LC23:
	.ascii "\0osr\0"
.LC22:
	.ascii "\0otu\0"
.LC21:
	.ascii "\0otl\0"
.LC20:
	.ascii "\0ote\0"
.LC19:
	.ascii "\0xio\0"
.LC18:
	.ascii "\0xic\0"
.LC17:
	.ascii "\0del\0"
.LC16:
	.ascii "\0newbra\0"
.LC15:
	.ascii "\0rung\0"
.LC14:
	.ascii "\0save\0"
.LC13:
	.ascii "\0open\0"
.LC12:
	.ascii "\0newfile\0"
.LC11:
	.ascii "\0arrow\0"
.globl noTools
.data
	.even
noTools:
	.long .LC29+5
	.long .LC30+8
	.long .LC31+8
	.long .LC32+7
	.long .LC33+7
	.long .LC34+8
	.long .LC35+8
	.long .LC36+8
	.long .LC37+8
.data
.LC37:
	.ascii "\0vertend\0"
.LC36:
	.ascii "\0vertbeg\0"
.LC35:
	.ascii "\0bendend\0"
.LC34:
	.ascii "\0bendbeg\0"
.LC33:
	.ascii "\0braend\0"
.LC32:
	.ascii "\0brabeg\0"
.LC31:
	.ascii "\0rungend\0"
.LC30:
	.ascii "\0rungbeg\0"
.LC29:
	.ascii "\0wire\0"
.globl showGrid
.data
	.even
showGrid:
	.word 0
.globl showRungs
	.even
showRungs:
	.word 1
.data
	.even
.globl show_picvar
show_picvar:
	link.w %a6,#0
	move.l %a2,-(%sp)
	clr.w -(%sp)
	move.l 8(%a6),-(%sp)
	move.l 2572(%a5),%a0
	jsr (%a0)
	move.l %a0,%a2
	addq.l #6,%sp
	cmp.w #0,%a2
	jbeq .L49
	move.w 12(%a2),-(%sp)
	move.l 2332(%a5),%a0
	jsr (%a0)
	addq.l #2,%sp
	cmp.b #223,(%a0)
	jbne .L49
	move.w 16(%a6),-(%sp)
	move.l 200.w,%a0
	move.l 188(%a0),-(%sp)
	move.w 12(%a2),-(%sp)
	move.l 600(%a5),%a0
	jsr (%a0)
	addq.l #2,%sp
	pea 2(%a0)
	move.w 14(%a6),-(%sp)
	move.w 12(%a6),-(%sp)
	move.l 1564(%a5),%a0
	jsr (%a0)
	moveq.l #1,%d0
	jbra .L50
	.even
.L49:
	clr.w %d0
.L50:
	move.l -4(%a6),%a2
	unlk %a6
	rts
.LC38:
	.ascii "N-A\0"
.LC39:
	.ascii "Rung #\0"
.LC40:
	.ascii "%d\0"
	.even
.globl newRung
newRung:
	link.w %a6,#-24
	movm.l #0x1820,-(%sp)
	move.w 8(%a6),%d3
	pea 160.w
	move.l 648(%a5),%a0
	jsr (%a0)
	move.l %a0,%a2
	move.w %d3,(%a2)
	clr.l 156(%a2)
	move.w #21,2(%a2)
	pea 4.w
	move.l 648(%a5),%a0
	jsr (%a0)
	move.l %a0,4(%a2)
	pea .LC38
	move.l %a0,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	pea .LC39
	moveq.l #-24,%d4
	add.l %a6,%d4
	move.l %d4,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w %d3,-(%sp)
	pea .LC40
	move.l %a6,%d3
	subq.l #4,%d3
	move.l %d3,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	lea (30,%sp),%sp
	move.l %d3,(%sp)
	move.l %d4,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	pea 20.w
	move.l 648(%a5),%a0
	jsr (%a0)
	move.l %a0,8(%a2)
	move.l %d4,-(%sp)
	move.l %a0,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	moveq.l #1,%d1
	.even
.L55:
	move.w %d1,%d0
	muls.w #14,%d0
	move.w #20,2(%a2,%d0.l)
	clr.w 12(%a2,%d0.l)
	clr.w 14(%a2,%d0.l)
	addq.w #1,%d1
	cmp.w #10,%d1
	jble .L55
	move.l %a2,%a0
	movm.l -36(%a6),#0x418
	unlk %a6
	rts
	.even
.globl copyRow
copyRow:
	link.w %a6,#0
	move.w 8(%a6),%d2
	move.l ladder,%a0
	clr.w %d1
	cmp.w #0,%a0
	jbeq .L58
	jbra .L64
	.even
.L61:
	addq.w #1,%d1
	move.l %d0,%a0
.L64:
	move.l 156(%a0),%d0
	jbeq .L58
	cmp.w %d1,%d2
	jbgt .L61
.L58:
	unlk %a6
	rts
	.even
.globl insertRung
insertRung:
	link.w %a6,#-24
	movm.l #0x1030,-(%sp)
	move.l 8(%a6),%a3
	cmp.w #0,%a3
	jbne .L66
	clr.w -(%sp)
	jbsr newRung
	move.l %a0,ladder
	jbra .L67
	.even
.L66:
	move.l ladder,%d1
	cmp.l %a3,%d1
	jbne .L68
	clr.w -(%sp)
	jbsr newRung
	move.l %a0,%a2
	move.l ladder,156(%a2)
	move.l %a2,ladder
	move.l 156(%a2),%a2
	jbra .L87
	.even
.L68:
	move.w y,%d0
	add.w winOffset,%d0
	cmp.w entries.l,%d0
	jblt .L70
	tst.l 156(%a3)
	jbeq .L72
	.even
.L73:
	move.l 156(%a3),%a3
	tst.l 156(%a3)
	jbne .L73
.L72:
	move.w (%a3),-(%sp)
	jbsr newRung
	move.l %a0,%a2
	move.l %a2,156(%a3)
	jbra .L87
	.even
.L70:
	move.l %d1,%a2
	move.l 156(%a2),%a0
	cmp.w #0,%a0
	jbeq .L77
	move.w (%a3),%d0
	cmp.w (%a0),%d0
	jble .L77
	.even
.L78:
	move.l %a0,%a2
	move.l 156(%a2),%a0
	cmp.w #0,%a0
	jbeq .L77
	cmp.w (%a0),%d0
	jbgt .L78
.L77:
	move.w (%a3),-(%sp)
	jbsr newRung
	move.l %a0,156(%a2)
	move.l %a3,156(%a0)
	move.l 156(%a2),%a0
	move.l 156(%a0),%a2
.L87:
	addq.l #2,%sp
	cmp.w #0,%a2
	jbeq .L67
	.even
.L83:
	cmp.w #21,2(%a2)
	jbne .L84
	pea .LC39
	moveq.l #-24,%d3
	add.l %a6,%d3
	move.l %d3,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w (%a2),-(%sp)
	pea .LC40
	lea (-4,%a6),%a3
	move.l %a3,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.l %a3,-(%sp)
	move.l %d3,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	move.l 8(%a2),-(%sp)
	move.l %d3,-(%sp)
	move.l 2500(%a5),%a0
	jsr (%a0)
	lea (34,%sp),%sp
	tst.w %d0
	jbne .L84
	pea .LC39
	move.l %d3,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w (%a2),%d0
	addq.w #1,%d0
	move.w %d0,-(%sp)
	pea .LC40
	move.l %a3,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.l %a3,-(%sp)
	move.l %d3,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	pea 20.w
	move.l 648(%a5),%a0
	jsr (%a0)
	move.l %a0,8(%a2)
	move.l %d3,-(%sp)
	move.l %a0,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
.L84:
	addq.w #1,(%a2)
	move.l 156(%a2),%a2
	cmp.w #0,%a2
	jbne .L83
.L67:
	addq.w #1,entries
	movm.l -36(%a6),#0xc08
	unlk %a6
	rts
	.even
.globl isFree
isFree:
	link.w %a6,#0
	move.l 8(%a6),%a1
	move.w #1,%a0
	move.w 12(%a6),%d1
	move.w x,%d2
	cmp.w %d1,%d2
	jblt .L90
	.even
.L92:
	move.w %d1,%d0
	muls.w #14,%d0
	cmp.w #-1,2(%a1,%d0.l)
	jbeq .L91
	sub.l %a0,%a0
.L91:
	addq.w #1,%d1
	cmp.w %d1,%d2
	jbge .L92
.L90:
	move.w %a0,%d0
	unlk %a6
	rts
	.even
.globl newBranch
newBranch:
	link.w %a6,#0
	move.l %d4,-(%sp)
	move.l %d3,-(%sp)
	move.w 8(%a6),%d3
	clr.w %d4
	pea 160.w
	move.l 648(%a5),%a0
	jsr (%a0)
	move.w %d3,(%a0)
	clr.l 156(%a0)
	.even
.L99:
	move.w %d4,%d0
	muls.w #14,%d0
	move.w #-1,2(%a0,%d0.l)
	addq.w #1,%d4
	cmp.w #10,%d4
	jble .L99
	move.l -8(%a6),%d3
	move.l -4(%a6),%d4
	unlk %a6
	rts
	.even
.globl insertBranch
insertBranch:
	link.w %a6,#0
	movm.l #0x1830,-(%sp)
	move.l 8(%a6),%a3
	move.w 12(%a6),%d4
	cmp.w #0,%a3
	jbeq .L102
	move.w %d4,%d3
	muls.w #14,%d3
	lea (2,%a3),%a0
	move.w (%a0,%d3.l),%d0
	cmp.w #20,%d0
	jbeq .L105
	cmp.w #25,%d0
	jbne .L103
	move.w #21,(%a0,%d3.l)
	jbra .L103
	.even
.L105:
	move.w #23,(%a0,%d3.l)
.L103:
	cmp.w #8,%d4
	jbgt .L114
	move.w x,%d0
	muls.w #14,%d0
	move.w (%a0,%d0.l),%d1
	cmp.w #20,%d1
	jbne .L139
	move.w #24,(%a0,%d0.l)
	jbra .L114
	.even
.L116:
	move.l 156(%a3),%a3
	lea (2,%a3),%a0
	move.w (%a0,%d3.l),%d0
	cmp.w #-1,%d0
	jbeq .L120
	cmp.w #25,%d0
	jbne .L118
	move.w #21,(%a0,%d3.l)
	jbra .L118
	.even
.L120:
	move.w #27,(%a0,%d3.l)
.L118:
	cmp.w #8,%d4
	jbgt .L114
	move.w x,%d0
	muls.w #14,%d0
	move.w (%a0,%d0.l),%d1
	cmp.w #-1,%d1
	jbeq .L126
.L139:
	cmp.w #26,%d1
	jbne .L114
	move.w #22,(%a0,%d0.l)
	jbra .L114
	.even
.L126:
	move.w #28,(%a0,%d0.l)
.L114:
	move.l 156(%a3),%a0
	cmp.w #0,%a0
	jbeq .L130
	move.w (%a3),%d0
	cmp.w (%a0),%d0
	jbne .L115
	move.w %d4,-(%sp)
	move.l %a0,-(%sp)
	jbsr isFree
	addq.l #6,%sp
	tst.w %d0
	jbeq .L116
.L115:
	move.l 156(%a3),%d0
	jbeq .L130
	move.l %d0,%a2
	move.w (%a3),%d0
	cmp.w (%a2),%d0
	jbeq .L131
.L130:
	move.l 156(%a3),%a2
	move.w (%a3),-(%sp)
	jbsr newBranch
	move.l %a0,156(%a3)
	move.l %a2,156(%a0)
	move.l 156(%a3),%a2
	addq.w #1,entries
.L131:
	move.w %d4,%d0
	muls.w #14,%d0
	lea (2,%a2),%a0
	move.w #25,(%a0,%d0.l)
	cmp.w #8,%d4
	jbgt .L132
	move.w %d4,%d1
	addq.w #1,%d1
	move.w x,%d2
	cmp.w %d1,%d2
	jble .L134
	.even
.L136:
	move.w %d1,%d0
	muls.w #14,%d0
	move.w #20,(%a0,%d0.l)
	addq.w #1,%d1
	cmp.w %d1,%d2
	jbgt .L136
.L134:
	move.w x,%d0
	muls.w #14,%d0
	move.w #26,2(%a2,%d0.l)
	jbra .L102
	.even
.L132:
	move.w #20,142(%a2)
.L102:
	movm.l -16(%a6),#0xc18
	unlk %a6
	rts
	.even
.globl copyCell
copyCell:
	link.w %a6,#-16
	move.l %d3,-(%sp)
	move.l %a1,%d3
	move.w y,%d0
	add.w winOffset,%d0
	move.w %d0,-(%sp)
	jbsr copyRow
	move.w #-1,-14(%a6)
	addq.l #2,%sp
	cmp.w #0,%a0
	jbne .L141
	move.w #14,-(%sp)
	move.l %d3,-(%sp)
	pea -14(%a6)
	jbsr bcopy
	jbra .L140
	.even
.L141:
	move.w x,%d0
	muls.w #14,%d0
	move.w #14,-(%sp)
	move.l %d3,-(%sp)
	pea 2(%a0,%d0.l)
	jbsr bcopy
.L140:
	move.l %d3,%a0
	move.l -20(%a6),%d3
	unlk %a6
	rts
.LC41:
	.ascii "I:0\0"
.LC42:
	.ascii "Input\0"
.LC43:
	.ascii "O:0\0"
.LC44:
	.ascii "Output\0"
.LC45:
	.ascii "B:0\0"
.LC46:
	.ascii "Flag\0"
.LC47:
	.ascii "C:0\0"
.LC48:
	.ascii "Counter\0"
.LC49:
	.ascii "10\0"
.LC50:
	.ascii "T:0\0"
.LC51:
	.ascii "Timer\0"
.LC52:
	.ascii "100\0"
.LC53:
	.ascii "Reset\0"
.LC54:
	.ascii "Label 1\0"
	.even
.globl insertCell
insertCell:
	link.w %a6,#-24
	movm.l #0x1030,-(%sp)
	move.w 8(%a6),%d3
	move.w y,%d0
	add.w winOffset,%d0
	move.w %d0,-(%sp)
	jbsr copyRow
	move.l %a0,%a2
	addq.l #2,%sp
	cmp.w #0,%a2
	jbeq .L143
	move.w x,%d0
	muls.w #14,%d0
	move.w %d3,2(%a2,%d0.l)
	pea 4.w
	move.l 648(%a5),%a0
	jsr (%a0)
	move.w x,%d0
	muls.w #14,%d0
	lea (4,%a2),%a3
	move.l %a0,(%a3,%d0.l)
	pea 20.w
	move.l 648(%a5),%a0
	jsr (%a0)
	move.w x,%d0
	muls.w #14,%d0
	addq.l #8,%a2
	move.l %a0,(%a2,%d0.l)
	addq.l #8,%sp
	move.w %d3,%d0
	subq.w #7,%d0
	cmp.w #10,%d0
	jbhi .L144
	and.l #0xFFFF,%d0
	add.l %d0,%d0
	.set .LI160,.+2
	move.w .L160-.LI160.b(%pc,%d0.l),%d0
	jmp %pc@(2,%d0:w)
	.even
.L160:
	.word .L146-.L160
	.word .L146-.L160
	.word .L149-.L160
	.word .L149-.L160
	.word .L149-.L160
	.word .L150-.L160
	.word .L151-.L160
	.word .L154-.L160
	.word .L157-.L160
	.word .L159-.L160
	.word .L159-.L160
	.even
.L146:
	pea .LC41
	pea -4(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	pea .LC42
	jbra .L162
	.even
.L149:
	pea .LC43
	pea -4(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	pea .LC44
	jbra .L162
	.even
.L150:
	pea .LC45
	pea -4(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	pea .LC46
	jbra .L162
	.even
.L151:
	pea .LC47
	pea -4(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	addq.l #8,%sp
	cmp.w #10,x.l
	jbne .L152
	pea .LC48
	jbra .L163
	.even
.L152:
	pea .LC49
	jbra .L163
	.even
.L154:
	pea .LC50
	pea -4(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	addq.l #8,%sp
	cmp.w #10,x.l
	jbne .L155
	pea .LC51
	jbra .L163
	.even
.L155:
	pea .LC52
.L163:
	pea -24(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	addq.l #8,%sp
	jbra .L144
	.even
.L157:
	pea .LC47
	pea -4(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	pea .LC53
	jbra .L162
	.even
.L159:
	pea .LC38
	pea -4(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	pea .LC54
.L162:
	pea -24(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	lea (16,%sp),%sp
.L144:
	pea -4(%a6)
	move.w x,%d0
	muls.w #14,%d0
	move.l (%a3,%d0.l),-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	pea -24(%a6)
	move.w x,%d0
	muls.w #14,%d0
	move.l (%a2,%d0.l),-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
.L143:
	movm.l -36(%a6),#0xc08
	unlk %a6
	rts
.LC55:
	.ascii "\0full\0"
	.even
.globl cursor
cursor:
	link.w %a6,#0
	move.w x,%d2
	cmp.w #-1,%d2
	jbne .L165
	move.w #2,-(%sp)
	move.w y,%d1
	move.w %d1,%d0
	lsl.w #1,%d0
	add.w %d1,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	clr.w -(%sp)
	pea .LC55+5
	jbsr show_picvar
	jbra .L166
	.even
.L165:
	move.w #2,-(%sp)
	move.w y,%d0
	move.w %d0,%d1
	lsl.w #1,%d1
	add.w %d0,%d1
	lsl.w #2,%d1
	add.w #18,%d1
	move.w %d1,-(%sp)
	move.w %d2,%d0
	lsl.w #1,%d0
	add.w %d2,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	pea .LC55+5
	jbsr show_picvar
.L166:
	unlk %a6
	rts
	.even
.globl grid
grid:
	link.w %a6,#0
	movm.l #0x1c20,-(%sp)
	lea cursor,%a2
	jsr (%a2)
	tst.w showGrid
	sne %d0
	move.b %d0,%d3
	ext.w %d3
	neg.w %d3
	moveq.l #18,%d5
	.even
.L172:
	moveq.l #18,%d4
	.even
.L176:
	move.w %d3,-(%sp)
	move.w %d4,-(%sp)
	move.w %d5,-(%sp)
	move.l 1696(%a5),%a0
	jsr (%a0)
	addq.l #6,%sp
	add.w #12,%d4
	cmp.w #99,%d4
	jble .L176
	add.w #12,%d5
	cmp.w #159,%d5
	jble .L172
	jsr (%a2)
	movm.l -16(%a6),#0x438
	unlk %a6
	rts
.LC56:
	.ascii "\0blank\0"
.LC57:
	.ascii "\0up\0"
.LC58:
	.ascii "\0down\0"
	.even
.globl toolRefresh
toolRefresh:
	link.w %a6,#0
	movm.l #0x1820,-(%sp)
	moveq.l #18,%d4
	moveq.l #5,%d3
	.even
.L183:
	move.w #4,-(%sp)
	move.w %d4,-(%sp)
	clr.w -(%sp)
	pea .LC56+6
	lea show_picvar,%a2
	jsr (%a2)
	lea (10,%sp),%sp
	add.w #12,%d4
	dbra %d3,.L183
	tst.w toolOffset
	jbne .L185
	move.w #2,-(%sp)
	move.w #18,-(%sp)
	clr.w -(%sp)
	move.l tools,-(%sp)
	jbra .L194
	.even
.L185:
	move.w #2,-(%sp)
	move.w #18,-(%sp)
	clr.w -(%sp)
	pea .LC57+3
.L194:
	jsr (%a2)
	lea (10,%sp),%sp
	moveq.l #1,%d3
	moveq.l #30,%d4
	.even
.L190:
	move.w #2,-(%sp)
	move.w %d4,-(%sp)
	clr.w -(%sp)
	move.w %d3,%d0
	add.w toolOffset,%d0
	ext.l %d0
	lsl.l #2,%d0
	lea tools,%a0
	move.l (%a0,%d0.l),-(%sp)
	lea show_picvar,%a2
	jsr (%a2)
	lea (10,%sp),%sp
	add.w #12,%d4
	addq.w #1,%d3
	cmp.w #4,%d3
	jble .L190
	cmp.w #12,toolOffset.l
	jbne .L192
	move.w #2,-(%sp)
	move.w %d3,%d0
	lsl.w #1,%d0
	add.w %d3,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	clr.w -(%sp)
	move.l tools+68,-(%sp)
	jsr (%a2)
	jbra .L193
	.even
.L192:
	move.w #2,-(%sp)
	move.w %d3,%d0
	lsl.w #1,%d0
	add.w %d3,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	clr.w -(%sp)
	pea .LC58+5
	jsr (%a2)
.L193:
	movm.l -12(%a6),#0x418
	unlk %a6
	rts
	.even
.globl refresh
refresh:
	link.w %a6,#-12
	movm.l #0x1f38,-(%sp)
	clr.w -6(%a6)
	move.l ladder,%a2
	jbsr clrscr
	jbsr toolRefresh
	move.w winOffset,%d0
	cmp.w -6(%a6),%d0
	jble .L197
	move.w %d0,%d3
	.even
.L199:
	move.l 156(%a2),%a2
	subq.w #1,%d3
	jbne .L199
.L197:
	cmp.w #0,%a2
	sne %d1
	ext.w %d1
	neg.w %d1
	neg.w %d0
	cmp.w #5,%d0
	sle %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L217
	move.w -6(%a6),%d0
	lsl.w #1,%d0
	add.w -6(%a6),%d0
	lsl.w #2,%d0
	move.w %d0,%d4
	add.w #18,%d4
	move.w %d4,%a4
	move.w %a4,-8(%a6)
	move.w %d0,%d7
	add.w #24,%d7
	move.w %d0,%a3
	move.w %a3,-10(%a6)
	.even
.L203:
	clr.w %d3
	moveq.l #18,%d6
	moveq.l #18,%d5
	.even
.L207:
	move.w %d3,%d0
	muls.w #14,%d0
	move.w 2(%a2,%d0.l),%d0
	cmp.w #-1,%d0
	jbeq .L206
	cmp.w #19,%d0
	jbgt .L209
	move.w #4,-(%sp)
	move.w -10(%a6),%d1
	add.w #18,%d1
	move.w %d1,-(%sp)
	move.w %d5,-(%sp)
	ext.l %d0
	lsl.l #2,%d0
	lea tools,%a0
	jbra .L218
	.even
.L209:
	move.w #4,-(%sp)
	move.w %a3,%d1
	add.w #18,%d1
	move.w %d1,-(%sp)
	move.w %d6,-(%sp)
	add.w #-20,%d0
	ext.l %d0
	lsl.l #2,%d0
	lea noTools,%a0
.L218:
	move.l (%a0,%d0.l),-(%sp)
	jbsr show_picvar
	lea (10,%sp),%sp
.L206:
	add.w #12,%d6
	add.w #12,%d5
	addq.w #1,%d3
	cmp.w #10,%d3
	jble .L207
	cmp.w #21,2(%a2)
	seq %d1
	ext.w %d1
	neg.w %d1
	cmp.w #5,-6(%a6)
	sle %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	and.w showRungs,%d1
	jbeq .L212
	move.w (%a2),-(%sp)
	pea .LC40
	move.l %a6,%d3
	subq.l #4,%d3
	move.l %d3,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.l %d3,-(%sp)
	move.w %d7,-(%sp)
	move.w #17,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	lea (20,%sp),%sp
.L212:
	cmp.w #-1,2(%a2)
	jbne .L213
	move.w #4,-(%sp)
	move.w -8(%a6),-(%sp)
	move.w #18,-(%sp)
	pea .LC36+8
	jbsr show_picvar
	lea (10,%sp),%sp
.L213:
	cmp.w #-1,142(%a2)
	jbne .L214
	move.w #4,-(%sp)
	move.w %a4,-(%sp)
	move.w #150,-(%sp)
	pea .LC37+8
	jbra .L219
	.even
.L214:
	move.w #4,-(%sp)
	move.w %d4,-(%sp)
	move.w #150,-(%sp)
	pea .LC31+8
.L219:
	jbsr show_picvar
	lea (10,%sp),%sp
	move.l 156(%a2),%a2
	add.w #12,%d4
	lea (12,%a4),%a4
	add.w #12,-8(%a6)
	add.w #12,%d7
	lea (12,%a3),%a3
	add.w #12,-10(%a6)
	addq.w #1,-6(%a6)
	cmp.w #0,%a2
	sne %d0
	ext.w %d0
	neg.w %d0
	move.w -6(%a6),%d1
	sub.w winOffset,%d1
	cmp.w #5,%d1
	sle %d1
	ext.w %d1
	neg.w %d1
	and.w %d1,%d0
	jbne .L203
.L217:
	jbsr cursor
	jbsr grid
	move.w #1,refreshMenu
	move.w #7,-(%sp)
	move.w #93,-(%sp)
	move.w #14,-(%sp)
	move.w #16,-(%sp)
	move.w #14,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.w #93,-(%sp)
	move.w #159,-(%sp)
	move.w #16,-(%sp)
	move.w #159,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.w #93,-(%sp)
	move.w #160,-(%sp)
	move.w #93,-(%sp)
	clr.w -(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	movm.l -44(%a6),#0x1cf8
	unlk %a6
	rts
.LC59:
	.ascii "Ti-PLC \"Help\" (1/3)\0"
.LC60:
	.ascii "You should read the enclosed\0"
.LC61:
	.ascii "manual, but here are the basics:\0"
.LC62:
	.ascii "1) Valid addresses:\0"
.LC63:
	.ascii "    Inputs:         I:0 through I:7\0"
.LC64:
	.ascii "    Outputs:      O:0 through O:7\0"
.LC65:
	.ascii "    Flags:          B:0 through B:7\0"
.LC66:
	.ascii "    Counters:   C:0 through C:7\0"
.LC67:
	.ascii "    Timers:       T:0 through T:7\0"
.LC68:
	.ascii "Ti-PLC \"Help\" (2/3)\0"
.LC69:
	.ascii "2) ALL actions go at the last\0"
.LC70:
	.ascii "    (rightmost) cell!\0"
.LC71:
	.ascii "3) Everything not located at the\0"
.LC72:
	.ascii "    last cell is considered as\0"
.LC73:
	.ascii "    part of a condition.\0"
.LC74:
	.ascii "4) Labels go at the first\0"
.LC75:
	.ascii "    cell (after rung numbers).\0"
.LC76:
	.ascii "Ti-PLC \"Help\" (3/3)\0"
.LC77:
	.ascii "5) To increment (or decrement) a \0"
.LC78:
	.ascii "    timer or counter, place\0"
.LC79:
	.ascii "    its symbol as an action.\0"
.LC80:
	.ascii "6) To check for a certain value\0"
.LC81:
	.ascii "    of a timer or counter, place\0"
.LC82:
	.ascii "    its symbol within a condition.\0"
.LC83:
	.ascii "7) Mail me if you want to see more!\0"
	.even
.globl help
help:
	link.w %a6,#0
	move.l %d3,-(%sp)
	pea NoCallBack
	move.w #90,-(%sp)
	move.w #140,-(%sp)
	move.l 208(%a5),%a0
	jsr (%a0)
	move.w %d0,%d3
	clr.w -(%sp)
	move.w #1,-(%sp)
	pea .LC59
	move.w #8,-(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	pea .LC60
	move.w #7,-(%sp)
	move.w #15,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
	move.l #.LC61,(%sp)
	move.w #7,-(%sp)
	move.w #21,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC62
	move.w #7,-(%sp)
	move.w #33,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC63
	move.w #7,-(%sp)
	move.w #45,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
	move.l #.LC64,(%sp)
	move.w #7,-(%sp)
	move.w #51,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC65
	move.w #7,-(%sp)
	move.w #57,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC66
	move.w #7,-(%sp)
	move.w #63,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
	move.l #.LC67,(%sp)
	move.w #7,-(%sp)
	move.w #69,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	clr.l -(%sp)
	clr.l -(%sp)
	move.w #-1,-(%sp)
	move.w #-1,-(%sp)
	move.w %d3,-(%sp)
	move.l 200(%a5),%a0
	jsr (%a0)
	move.w %d3,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	lea (28,%sp),%sp
	move.l #NoCallBack,(%sp)
	move.w #90,-(%sp)
	move.w #140,-(%sp)
	move.l 208(%a5),%a0
	jsr (%a0)
	move.w %d0,%d3
	clr.w -(%sp)
	move.w #1,-(%sp)
	pea .LC68
	move.w #8,-(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	pea .LC69
	move.w #7,-(%sp)
	move.w #15,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
	move.l #.LC70,(%sp)
	move.w #7,-(%sp)
	move.w #21,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC71
	move.w #7,-(%sp)
	move.w #33,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC72
	move.w #7,-(%sp)
	move.w #39,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
	move.l #.LC73,(%sp)
	move.w #7,-(%sp)
	move.w #45,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC74
	move.w #7,-(%sp)
	move.w #57,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC75
	move.w #7,-(%sp)
	move.w #63,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
	clr.l (%sp)
	clr.l -(%sp)
	move.w #-1,-(%sp)
	move.w #-1,-(%sp)
	move.w %d3,-(%sp)
	move.l 200(%a5),%a0
	jsr (%a0)
	move.w %d3,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	pea NoCallBack
	move.w #90,-(%sp)
	move.w #140,-(%sp)
	move.l 208(%a5),%a0
	jsr (%a0)
	move.w %d0,%d3
	clr.w -(%sp)
	move.w #1,-(%sp)
	pea .LC76
	move.w #8,-(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (44,%sp),%sp
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	pea .LC77
	move.w #7,-(%sp)
	move.w #15,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC78
	move.w #7,-(%sp)
	move.w #21,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC79
	move.w #7,-(%sp)
	move.w #27,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (40,%sp),%sp
	move.l #.LC80,(%sp)
	move.w #7,-(%sp)
	move.w #39,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC81
	move.w #7,-(%sp)
	move.w #45,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC82
	move.w #7,-(%sp)
	move.w #51,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
	move.l #.LC83,(%sp)
	move.w #7,-(%sp)
	move.w #63,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	clr.l -(%sp)
	clr.l -(%sp)
	move.w #-1,-(%sp)
	move.w #-1,-(%sp)
	move.w %d3,-(%sp)
	move.l 200(%a5),%a0
	jsr (%a0)
	move.w %d3,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	move.l -4(%a6),%d3
	unlk %a6
	rts
.LC84:
	.ascii "About Ti-PLC\0"
.LC85:
	.ascii "           Ti-PLC, V1.05 \0"
.LC86:
	.ascii "            by Kuashio\0"
.LC87:
	.ascii "Comments and bug report go to\0"
.LC88:
	.ascii "        kuashio@hotmail.com\0"
.LC89:
	.ascii "This is the last you'll ever see of\0"
.LC90:
	.ascii "this program unless I get requests to\0"
.LC91:
	.ascii "finish it. Read the enclosed readme.\0"
	.even
.globl about
about:
	link.w %a6,#0
	move.l %d3,-(%sp)
	pea NoCallBack
	move.w #85,-(%sp)
	move.w #140,-(%sp)
	move.l 208(%a5),%a0
	jsr (%a0)
	move.w %d0,%d3
	clr.w -(%sp)
	move.w #1,-(%sp)
	pea .LC84
	move.w #8,-(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	pea .LC85
	move.w #7,-(%sp)
	move.w #15,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
	move.l #.LC86,(%sp)
	move.w #7,-(%sp)
	move.w #21,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC87
	move.w #7,-(%sp)
	move.w #33,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC88
	move.w #7,-(%sp)
	move.w #39,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
	move.l #.LC89,(%sp)
	move.w #7,-(%sp)
	move.w #51,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC90
	move.w #7,-(%sp)
	move.w #57,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC91
	move.w #7,-(%sp)
	move.w #63,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
	clr.l (%sp)
	clr.l -(%sp)
	move.w #-1,-(%sp)
	move.w #-1,-(%sp)
	move.w %d3,-(%sp)
	move.l 200(%a5),%a0
	jsr (%a0)
	move.w %d3,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	move.l -4(%a6),%d3
	unlk %a6
	rts
.LC92:
	.ascii "Up / Down\0"
.LC93:
	.ascii "Up\0"
.LC94:
	.ascii "Down\0"
.LC95:
	.ascii "Timer Type\0"
.LC96:
	.ascii "ON Timer\0"
.LC97:
	.ascii "Retentive\0"
.LC98:
	.ascii "Cell Properties\0"
.LC99:
	.ascii "Rung: \0"
.LC100:
	.ascii "Symbol: \0"
.LC101:
	.ascii "Address: \0"
.LC102:
	.ascii "Count : \0"
.LC103:
	.ascii "Timer Type : \0"
.LC104:
	.ascii "Preset Value: \0"
.LC105:
	.ascii "Symbol\0"
.LC106:
	.ascii "Label Name: \0"
.LC107:
	.ascii "Comments: \0"
.LC108:
	.ascii "Please enter a 3-character address\0"
.LC109:
	.ascii "Invalid Address\0"
	.even
.globl properties
properties:
	link.w %a6,#-60
	movm.l #0x1f38,-(%sp)
	move.w y,%d0
	add.w winOffset,%d0
	move.w %d0,-(%sp)
	jbsr copyRow
	move.l %a0,%a4
	move.w x,%d0
	muls.w #14,%d0
	lea 2(%a4,%d0.l),%a3
	pea 6.w
	move.l 648(%a5),%a0
	jsr (%a0)
	move.l %a0,-58(%a6)
	move.w 10(%a3),%d1
	addq.w #1,%d1
	move.w %d1,(%a0)
	move.w #80,-(%sp)
	pea .LC92
	move.l 276(%a5),%a0
	jsr (%a0)
	move.w %d0,%d7
	move.w #1,-(%sp)
	pea .LC93
	move.w #-1,-(%sp)
	move.w %d7,-(%sp)
	move.l 272(%a5),%a0
	jsr (%a0)
	move.w #2,-(%sp)
	pea .LC94
	move.w #-1,-(%sp)
	move.w %d7,-(%sp)
	move.l 272(%a5),%a0
	jsr (%a0)
	lea (32,%sp),%sp
	move.w #80,-(%sp)
	pea .LC95
	move.l 276(%a5),%a0
	jsr (%a0)
	move.w %d0,%d6
	move.w #1,-(%sp)
	pea .LC96
	move.w #-1,-(%sp)
	move.w %d6,-(%sp)
	move.l 272(%a5),%a0
	jsr (%a0)
	move.w #2,-(%sp)
	pea .LC97
	move.w #-1,-(%sp)
	move.w %d6,-(%sp)
	move.l 272(%a5),%a0
	jsr (%a0)
	move.w (%a3),%d0
	add.w #-13,%d0
	lea (26,%sp),%sp
	cmp.w #1,%d0
	jbhi .L223
	cmp.w #10,x.l
	jbne .L223
	pea NoCallBack
	move.w #70,-(%sp)
	jbra .L244
	.even
.L223:
	pea NoCallBack
	move.w #60,-(%sp)
.L244:
	move.w #140,-(%sp)
	move.l 208(%a5),%a0
	jsr (%a0)
	move.w %d0,%d5
	addq.l #8,%sp
	move.w #4,-(%sp)
	move.w #1,-(%sp)
	pea .LC98
	move.w #8,-(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC99
	lea (-26,%a6),%a2
	move.l %a2,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w (%a4),-(%sp)
	pea .LC40
	moveq.l #-30,%d3
	add.l %a6,%d3
	move.l %d3,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	lea (32,%sp),%sp
	move.l %d3,(%sp)
	move.l %a2,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	move.l %a2,-(%sp)
	move.w #7,-(%sp)
	move.w #15,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (22,%sp),%sp
	cmp.w #21,(%a3)
	jbeq .L225
	pea .LC100
	move.l %a2,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w (%a3),%d0
	subq.w #7,%d0
	ext.l %d0
	lsl.l #2,%d0
	lea symbolName,%a0
	move.l (%a0,%d0.l),-(%sp)
	move.l %a2,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	move.l %a2,-(%sp)
	move.w #7,-(%sp)
	move.w #15,-(%sp)
	move.w #50,-(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (30,%sp),%sp
.L225:
	pea .LC101
	move.l %a2,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.l 2(%a3),-(%sp)
	moveq.l #-34,%d4
	add.l %a6,%d4
	move.l %d4,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	lea (16,%sp),%sp
	cmp.w #21,(%a3)
	seq %d1
	ext.w %d1
	neg.w %d1
	cmp.w #10,x.l
	seq %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L226
	move.l %d4,-(%sp)
	move.l %a2,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	move.l %a2,-(%sp)
	move.w #7,-(%sp)
	move.w #25,%a4
	move.w %a4,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (22,%sp),%sp
	jbra .L227
	.even
.L226:
	move.w #4,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.l %a2,-(%sp)
	move.w #2,-(%sp)
	move.w #25,%a4
	move.w %a4,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (20,%sp),%sp
.L227:
	cmp.w #13,(%a3)
	seq %d1
	ext.w %d1
	neg.w %d1
	cmp.w #10,x.l
	seq %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L228
	clr.w -(%sp)
	move.w %d7,-(%sp)
	pea .LC102
	move.w #14,-(%sp)
	move.w #35,%a4
	move.w %a4,-(%sp)
	move.w #3,-(%sp)
	move.w #2,-(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (18,%sp),%sp
.L228:
	cmp.w #14,(%a3)
	seq %d1
	ext.w %d1
	neg.w %d1
	cmp.w #10,x.l
	seq %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L229
	clr.w -(%sp)
	move.w %d6,-(%sp)
	pea .LC103
	move.w #14,-(%sp)
	lea (10,%a4),%a4
	move.w %a4,-(%sp)
	move.w #3,-(%sp)
	move.w #2,-(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (18,%sp),%sp
.L229:
	move.w (%a3),%d2
	move.w %d2,%d0
	add.w #-13,%d0
	cmp.w #1,%d0
	sls %d1
	ext.w %d1
	neg.w %d1
	cmp.w #9,x.l
	sle %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L230
	pea .LC104
	move.l %a2,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	pea .LC105
	move.l 6(%a3),-(%sp)
	move.l 2500(%a5),%a0
	jsr (%a0)
	lea (16,%sp),%sp
	tst.w %d0
	jbne .L232
	pea .LC49
	move.l 6(%a3),-(%sp)
	jbra .L245
	.even
.L230:
	add.w #-16,%d2
	cmp.w #1,%d2
	jbhi .L233
	pea .LC106
	jbra .L246
	.even
.L233:
	pea .LC107
.L246:
	move.l %a2,-(%sp)
.L245:
	move.l 2480(%a5),%a0
	jsr (%a0)
	addq.l #8,%sp
.L232:
	move.l 6(%a3),-(%sp)
	moveq.l #-54,%d3
	add.l %a6,%d3
	move.l %d3,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w #12,-(%sp)
	move.w #19,-(%sp)
	move.l %d4,-(%sp)
	move.l 2552(%a5),%a0
	jsr (%a0)
	addq.l #4,%sp
	addq.w #1,%d0
	move.w %d0,-(%sp)
	lea (-26,%a6),%a2
	move.l %a2,-(%sp)
	move.w #2,-(%sp)
	lea (10,%a4),%a4
	move.w %a4,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	move.l %d4,-(%sp)
	move.l %a2,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	lea (32,%sp),%sp
	move.l %d4,(%sp)
	move.l 2552(%a5),%a0
	jsr (%a0)
	move.b #32,(%a2,%d0.l)
	move.l %d4,-(%sp)
	move.l 2552(%a5),%a0
	jsr (%a0)
	clr.b 1(%a2,%d0.l)
	move.l %d3,-(%sp)
	move.l %a2,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	move.l %d4,-(%sp)
	move.l 2552(%a5),%a0
	jsr (%a0)
	clr.b (%a2,%d0.l)
	move.l -58(%a6),-(%sp)
	move.l %a2,-(%sp)
	move.w #-1,-(%sp)
	move.w #-1,-(%sp)
	move.w %d5,-(%sp)
	move.l 200(%a5),%a0
	jsr (%a0)
	lea (34,%sp),%sp
	cmp.w #13,%d0
	jbne .L235
	move.l %a2,-(%sp)
	move.l 2552(%a5),%a0
	jsr (%a0)
	addq.l #4,%sp
	moveq.l #3,%d1
	cmp.l %d0,%d1
	jbne .L236
	move.l %a2,-(%sp)
	move.l 2552(%a5),%a0
	jsr (%a0)
	addq.l #1,%d0
	move.l %d0,-(%sp)
	move.l %a2,-(%sp)
	move.l 2(%a3),-(%sp)
	move.l 2484(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l %a2,-(%sp)
	move.l 2512(%a5),%a0
	jsr (%a0)
	pea 1(%a0)
	move.l 6(%a3),-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	lea (30,%sp),%sp
	move.l 2(%a3),%a0
	move.b (%a0),%d1
	ext.w %d1
	move.w %d1,%d0
	add.w #-97,%d0
	cmp.w #25,%d0
	jbhi .L237
	add.w #-32,%d1
.L237:
	move.b %d1,(%a0)
	move.w (%a3),%d0
	add.w #-13,%d0
	cmp.w #1,%d0
	jbhi .L235
	cmp.w #10,x.l
	jbne .L239
	move.l -58(%a6),%a0
	move.w (%a0),%d0
	subq.w #1,%d0
	move.w %d0,10(%a3)
	jbra .L235
	.even
.L239:
	move.l 6(%a3),%a0
	cmp.b #-83,(%a0)
	jbne .L235
	move.b #45,(%a0)
	jbra .L235
	.even
.L236:
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	addq.l #2,%sp
	tst.w x
	jble .L235
	clr.w -(%sp)
	move.w #1,-(%sp)
	pea .LC108
	pea .LC109
	move.l 1744(%a5),%a0
	jsr (%a0)
	lea (12,%sp),%sp
.L235:
	move.w %d5,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	move.w %d6,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	move.w %d7,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	movm.l -92(%a6),#0x1cf8
	unlk %a6
	rts
	.even
.globl stampLink
stampLink:
	link.w %a6,#0
	move.l %d3,-(%sp)
	move.b 9(%a6),%d3
	move.b #5,SerialDataRx
	jbsr OpenLinkPort
	move.l pLinkPort,%a0
	move.w #512,(%a0)
	jbsr SetBaudRate
	subq.l #2,%sp
	move.b %d3,1(%sp)
	jbsr SendByte
	move.l #100000,-(%sp)
	jbsr GetByte
	move.w %d0,%d3
	jbsr CloseLinkPort
	move.w %d3,%d0
	move.l -4(%a6),%d3
	unlk %a6
	rts
	.even
.globl drawRect
drawRect:
	link.w %a6,#0
	movm.l #0x1e00,-(%sp)
	move.w 8(%a6),%d3
	move.w 10(%a6),%d5
	move.w 12(%a6),%d6
	move.w 14(%a6),%d4
	move.w #1,-(%sp)
	move.w %d5,-(%sp)
	move.w %d6,-(%sp)
	move.w %d5,-(%sp)
	move.w %d3,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.w %d4,-(%sp)
	move.w %d3,-(%sp)
	move.w %d5,-(%sp)
	move.w %d3,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.w %d4,-(%sp)
	move.w %d6,-(%sp)
	move.w %d4,-(%sp)
	move.w %d3,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.w %d4,-(%sp)
	move.w %d6,-(%sp)
	move.w %d5,-(%sp)
	move.w %d6,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	movm.l -16(%a6),#0x78
	unlk %a6
	rts
.LC110:
	.ascii "C:\0"
.LC111:
	.ascii "T:\0"
.LC112:
	.ascii "Baud Rate\0"
.LC113:
	.ascii "%u\0"
.LC114:
	.ascii "Run Settings\0"
.LC115:
	.ascii "1st Counter Watch : \0"
.LC116:
	.ascii "2nd Counter Watch : \0"
.LC117:
	.ascii "1st Timer Watch : \0"
.LC118:
	.ascii "2nd Timer Watch : \0"
.LC119:
	.ascii "Emulator Baud Rate : \0"
	.even
.globl settings
settings:
	link.w %a6,#-8
	movm.l #0x1f38,-(%sp)
	pea 10.w
	move.l 648(%a5),%a0
	jsr (%a0)
	move.l %a0,%a2
	clr.b %d6
	addq.l #4,%sp
	.even
.L253:
	clr.l %d0
	move.b %d6,%d0
	move.l %d0,%d1
	add.l %d0,%d1
	lea watchIndex,%a0
	move.b (%a0,%d0.l),%d0
	and.w #0xFF,%d0
	addq.w #1,%d0
	move.w %d0,(%a2,%d1.l)
	addq.b #1,%d6
	cmp.b #3,%d6
	jbls .L253
	move.w BaudRateIndex,%d0
	addq.w #1,%d0
	move.w %d0,8(%a2)
	move.w #80,-(%sp)
	pea .LC48
	move.l 276(%a5),%a0
	jsr (%a0)
	move.w %d0,%a4
	move.w #80,-(%sp)
	pea .LC51
	move.l 276(%a5),%a0
	jsr (%a0)
	move.w %d0,%a3
	clr.b %d6
	lea (12,%sp),%sp
	.even
.L258:
	pea .LC110
	move.l %a6,%d4
	subq.l #4,%d4
	move.l %d4,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	clr.w %d5
	move.b %d6,%d5
	move.w %d5,-(%sp)
	pea .LC40
	move.l %a6,%d7
	subq.l #6,%d7
	move.l %d7,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.l %d7,-(%sp)
	move.l %d4,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	move.w %d5,%d3
	addq.w #1,%d3
	move.w %d3,-(%sp)
	move.l %d4,-(%sp)
	move.w #-1,-(%sp)
	move.w %a4,-(%sp)
	move.l 272(%a5),%a0
	jsr (%a0)
	lea (32,%sp),%sp
	move.l #.LC111,(%sp)
	move.l %d4,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w %d5,-(%sp)
	pea .LC40
	move.l %d7,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.l %d7,-(%sp)
	move.l %d4,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	move.w %d3,-(%sp)
	move.l %d4,-(%sp)
	move.w #-1,-(%sp)
	move.w %a3,-(%sp)
	move.l 272(%a5),%a0
	jsr (%a0)
	lea (36,%sp),%sp
	addq.b #1,%d6
	cmp.b #7,%d6
	jbls .L258
	move.w #90,-(%sp)
	pea .LC112
	move.l 276(%a5),%a0
	jsr (%a0)
	move.w %d0,%d4
	clr.b %d6
	addq.l #6,%sp
	.even
.L263:
	clr.l %d0
	move.b %d6,%d0
	add.l %d0,%d0
	lea BaudRateBreakPoints,%a0
	move.w (%a0,%d0.l),-(%sp)
	pea .LC113
	move.l %d7,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	clr.w %d0
	move.b %d6,%d0
	addq.w #1,%d0
	move.w %d0,-(%sp)
	move.l %d7,-(%sp)
	move.w #-1,-(%sp)
	move.w %d4,-(%sp)
	move.l 272(%a5),%a0
	jsr (%a0)
	lea (20,%sp),%sp
	addq.b #1,%d6
	cmp.b #8,%d6
	jbls .L263
	pea NoCallBack
	move.w #90,-(%sp)
	move.w #140,-(%sp)
	move.l 208(%a5),%a0
	jsr (%a0)
	move.w %d0,%d3
	move.w #4,-(%sp)
	move.w #1,-(%sp)
	pea .LC114
	move.w #8,-(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.w %a4,-(%sp)
	pea .LC115
	move.w #14,-(%sp)
	move.w #24,-(%sp)
	move.w #3,-(%sp)
	move.w #2,-(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (44,%sp),%sp
	move.w #1,-(%sp)
	move.w %a4,-(%sp)
	pea .LC116
	move.w #14,-(%sp)
	move.w #33,-(%sp)
	move.w #3,-(%sp)
	move.w #2,-(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	move.w #2,-(%sp)
	move.w %a3,-(%sp)
	pea .LC117
	move.w #14,-(%sp)
	move.w #42,-(%sp)
	move.w #3,-(%sp)
	move.w #2,-(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (36,%sp),%sp
	move.w #3,-(%sp)
	move.w %a3,-(%sp)
	pea .LC118
	move.w #14,-(%sp)
	move.w #51,-(%sp)
	move.w #3,-(%sp)
	move.w #2,-(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	move.w #4,-(%sp)
	move.w %d4,-(%sp)
	pea .LC119
	move.w #14,-(%sp)
	move.w #67,-(%sp)
	move.w #3,-(%sp)
	move.w #2,-(%sp)
	move.w %d3,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (32,%sp),%sp
	move.l %a2,(%sp)
	clr.l -(%sp)
	move.w #-1,-(%sp)
	move.w #-1,-(%sp)
	move.w %d3,-(%sp)
	move.l 200(%a5),%a0
	jsr (%a0)
	lea (14,%sp),%sp
	cmp.w #13,%d0
	jbne .L265
	clr.b %d6
	.even
.L269:
	clr.l %d0
	move.b %d6,%d0
	move.l %d0,%d1
	add.l %d0,%d1
	move.b 1(%a2,%d1.l),%d1
	subq.b #1,%d1
	lea watchIndex,%a0
	move.b %d1,(%a0,%d0.l)
	addq.b #1,%d6
	cmp.b #3,%d6
	jbls .L269
	move.w 8(%a2),%d0
	subq.w #1,%d0
	move.w %d0,BaudRateIndex
	jbsr SetBaudRate
.L265:
	move.l %a2,-(%sp)
	move.l 652(%a5),%a0
	jsr (%a0)
	move.w %a4,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	move.w %a3,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	move.w %d4,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	move.w %d3,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	movm.l -40(%a6),#0x1cf8
	unlk %a6
	rts
.LC120:
	.ascii "I:\0"
.LC121:
	.ascii "O:\0"
.LC122:
	.ascii "=\0"
.LC123:
	.ascii "Ti-PLC\0"
.LC124:
	.ascii "By Kuashio\0"
	.even
.globl drawPLC
drawPLC:
	link.w %a6,#-8
	movm.l #0x1e20,-(%sp)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	move.w #87,-(%sp)
	move.w #122,-(%sp)
	move.w #6,-(%sp)
	move.w #32,-(%sp)
	lea drawRect,%a2
	jsr (%a2)
	move.w #1,-(%sp)
	move.w #9,-(%sp)
	move.w #32,-(%sp)
	move.w #9,-(%sp)
	move.w #20,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.w #84,-(%sp)
	move.w #32,-(%sp)
	move.w #84,-(%sp)
	move.w #20,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.w #9,-(%sp)
	move.w #20,-(%sp)
	move.w #84,-(%sp)
	move.w #20,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	lea (40,%sp),%sp
	move.w #1,-(%sp)
	move.w #9,-(%sp)
	move.w #134,-(%sp)
	move.w #9,-(%sp)
	move.w #122,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.w #84,-(%sp)
	move.w #134,-(%sp)
	move.w #84,-(%sp)
	move.w #122,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.w #9,-(%sp)
	move.w #134,-(%sp)
	move.w #84,-(%sp)
	move.w #134,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	clr.w %d4
	lea (30,%sp),%sp
	moveq.l #13,%d6
	.even
.L275:
	pea .LC120
	move.l %a6,%d3
	subq.l #4,%d3
	move.l %d3,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w %d4,-(%sp)
	pea .LC40
	move.l %a6,%d5
	subq.l #6,%d5
	move.l %d5,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.l %d5,-(%sp)
	move.l %d3,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.l %d3,-(%sp)
	move.w %d6,-(%sp)
	move.w #34,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	lea (32,%sp),%sp
	move.l #.LC121,(%sp)
	move.l %d3,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w %d4,-(%sp)
	pea .LC40
	move.l %d5,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.l %d5,-(%sp)
	move.l %d3,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.l %d3,-(%sp)
	move.w %d6,-(%sp)
	move.w #110,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	lea (36,%sp),%sp
	add.w #9,%d6
	addq.w #1,%d4
	cmp.w #7,%d4
	jble .L275
	pea .LC110
	move.l %d3,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.l %d3,-(%sp)
	move.w #35,-(%sp)
	move.w #62,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.l %d3,-(%sp)
	move.w #44,-(%sp)
	move.w #62,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	move.b #84,-4(%a6)
	move.w #1,-(%sp)
	move.l %d3,-(%sp)
	move.w #53,-(%sp)
	move.w #62,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
	move.w #1,-(%sp)
	move.l %d3,-(%sp)
	move.w #62,-(%sp)
	move.w #62,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	clr.w %d4
	lea (10,%sp),%sp
	moveq.l #35,%d3
	.even
.L280:
	lea watchIndex,%a0
	clr.w %d0
	move.b (%a0,%d4.w),%d0
	move.w %d0,-(%sp)
	pea .LC40
	move.l %d5,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.l %d5,-(%sp)
	move.w %d3,-(%sp)
	move.w #68,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	pea .LC122
	move.w %d3,-(%sp)
	move.w #73,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	lea (30,%sp),%sp
	add.w #9,%d3
	addq.w #1,%d4
	cmp.w #3,%d4
	jble .L280
	clr.w %d4
	moveq.l #46,%d3
	.even
.L285:
	move.w %d4,-(%sp)
	pea .LC40
	move.l %d5,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.w #4,-(%sp)
	move.l %d5,-(%sp)
	move.w #73,-(%sp)
	move.w %d3,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	lea (20,%sp),%sp
	addq.w #8,%d3
	addq.w #1,%d4
	cmp.w #7,%d4
	jble .L285
	move.w #87,-(%sp)
	move.w #109,-(%sp)
	move.w #6,-(%sp)
	move.w #43,-(%sp)
	jsr (%a2)
	move.w #30,-(%sp)
	move.w #109,-(%sp)
	move.w #70,-(%sp)
	move.w #43,-(%sp)
	jsr (%a2)
	move.w #2,-(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	pea .LC123
	move.w #10,-(%sp)
	move.w #51,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	pea .LC124
	move.w #22,-(%sp)
	move.w #58,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	movm.l -28(%a6),#0x478
	unlk %a6
	rts
.LC125:
	.ascii "          \0"
.LC126:
	.ascii "\0on\0"
.LC127:
	.ascii "\0off\0"
	.even
.globl flush
flush:
	link.w %a6,#-12
	movm.l #0x1f38,-(%sp)
	move.b 13(%a6),%d0
	move.w %d0,%a4
	clr.w %d5
	moveq.l #35,%d4
	.even
.L291:
	move.w %d5,%a0
	add.l %a0,%a0
	lea watch,%a1
	move.w (%a0,%a1.l),-(%sp)
	pea .LC40
	moveq.l #-10,%d3
	add.l %a6,%d3
	move.l %d3,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.w #4,-(%sp)
	pea .LC125
	move.w %d4,-(%sp)
	move.w #78,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	move.l %d3,-(%sp)
	move.w %d4,-(%sp)
	move.w #78,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	lea (30,%sp),%sp
	add.w #9,%d4
	addq.w #1,%d5
	cmp.w #3,%d5
	jble .L291
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	clr.w %d5
	addq.l #2,%sp
	move.w #45,%a3
	move.w #45,%a2
	moveq.l #12,%d7
	moveq.l #12,%d6
	moveq.l #12,%d4
	moveq.l #12,%d3
	.even
.L296:
	move.b 9(%a6),%d0
	ext.w %d0
	asr.w %d5,%d0
	btst #0,%d0
	jbeq .L297
	move.w #4,-(%sp)
	move.w %d3,-(%sp)
	move.w #23,-(%sp)
	pea .LC126+3
	jbra .L304
	.even
.L297:
	move.w #4,-(%sp)
	move.w %d4,-(%sp)
	move.w #23,-(%sp)
	pea .LC127+4
.L304:
	jbsr show_picvar
	lea (10,%sp),%sp
	move.b 11(%a6),%d0
	ext.w %d0
	asr.w %d5,%d0
	btst #0,%d0
	jbeq .L299
	move.w #4,-(%sp)
	move.w %d6,-(%sp)
	move.w #125,-(%sp)
	pea .LC126+3
	jbra .L305
	.even
.L299:
	move.w #4,-(%sp)
	move.w %d7,-(%sp)
	move.w #125,-(%sp)
	pea .LC127+4
.L305:
	jbsr show_picvar
	lea (10,%sp),%sp
	move.w %a4,%d0
	ext.w %d0
	asr.w %d5,%d0
	btst #0,%d0
	jbeq .L301
	move.w #4,-(%sp)
	move.w #79,-(%sp)
	move.w %a2,-(%sp)
	pea .LC126+3
	jbra .L306
	.even
.L301:
	move.w #4,-(%sp)
	move.w #79,-(%sp)
	move.w %a3,-(%sp)
	pea .LC127+4
.L306:
	jbsr show_picvar
	lea (10,%sp),%sp
	addq.w #8,%a3
	addq.w #8,%a2
	add.w #9,%d7
	add.w #9,%d6
	add.w #9,%d4
	add.w #9,%d3
	addq.w #1,%d5
	cmp.w #7,%d5
	jble .L296
	movm.l -44(%a6),#0x1cf8
	unlk %a6
	rts
	.even
.globl keyAction
keyAction:
	link.w %a6,#0
	movm.l #0x1c20,-(%sp)
	move.w 8(%a6),%d3
	clr.w %d4
	cmp.w #337,%d3
	seq %d1
	ext.w %d1
	neg.w %d1
	cmp.w #344,%d3
	seq %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	cmp.w #340,%d3
	seq %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	cmp.w #338,%d3
	seq %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	jbeq .L308
	lea cursor,%a2
	jsr (%a2)
	cmp.w #338,%d3
	jbeq .L321
	jbgt .L324
	cmp.w #337,%d3
	jbeq .L310
	jbra .L309
	.even
.L324:
	cmp.w #340,%d3
	jbeq .L316
	cmp.w #344,%d3
	jbeq .L315
	jbra .L309
	.even
.L310:
	move.w y,%d0
	jbne .L311
	cmp.w #-1,x.l
	seq %d1
	ext.w %d1
	neg.w %d1
	move.w toolOffset,%d2
	sgt %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L312
	subq.w #1,%d2
	move.w %d2,toolOffset
	jbsr toolRefresh
.L312:
	move.w x,%d1
	not.w %d1
	move.w winOffset,%d2
	sgt %d0
	ext.w %d0
	moveq.l #15,%d5
	lsr.w %d5,%d1
	and.w %d0,%d1
	jbeq .L309
	subq.w #1,%d2
	jbra .L349
	.even
.L311:
	subq.w #1,%d0
	move.w %d0,y
	jbra .L309
	.even
.L315:
	addq.w #1,x
	jbra .L309
	.even
.L316:
	move.w y,%d0
	cmp.w #5,%d0
	jbne .L317
	cmp.w #-1,x.l
	seq %d1
	ext.w %d1
	neg.w %d1
	move.w toolOffset,%d2
	cmp.w #11,%d2
	sle %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L318
	addq.w #1,%d2
	move.w %d2,toolOffset
	jbsr toolRefresh
.L318:
	move.w x,%d0
	not.w %d0
	move.w entries,%d1
	subq.w #1,%d1
	move.w winOffset,%d2
	cmp.w %d2,%d1
	sgt %d1
	ext.w %d1
	moveq.l #15,%d5
	lsr.w %d5,%d0
	and.w %d1,%d0
	jbeq .L309
	addq.w #1,%d2
.L349:
	move.w %d2,winOffset
	jbsr refresh
	clr.w %d0
	jbra .L348
	.even
.L317:
	addq.w #1,%d0
	move.w %d0,y
	jbra .L309
	.even
.L321:
	subq.w #1,x
.L309:
	cmp.w #65534,x.l
	jbgt .L325
	move.w #-1,x
.L325:
	cmp.w #10,x.l
	jble .L326
	move.w #10,x
.L326:
	tst.w y
	jbge .L327
	clr.w y
.L327:
	cmp.w #5,y.l
	jble .L328
	move.w #5,y
.L328:
	jsr (%a2)
.L308:
	cmp.w #265,%d3
	jbeq .L340
	jbgt .L346
	cmp.w #263,%d3
	jbeq .L343
	jbgt .L337
	cmp.w #13,%d3
	jbeq .L330
	jbra .L329
	.even
.L346:
	cmp.w #274,%d3
	jbeq .L340
	jbgt .L347
	cmp.w #266,%d3
	jbeq .L343
	jbra .L329
	.even
.L347:
	cmp.w #4360,%d3
	jbeq .L338
	cmp.w #4361,%d3
	jbeq .L343
	jbra .L329
	.even
.L330:
	cmp.w #-1,x.l
	jbne .L331
	move.w y,%d3
	seq %d1
	ext.w %d1
	neg.w %d1
	move.w toolOffset,%d2
	sgt %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L332
	subq.w #1,%d2
	jbra .L350
	.even
.L332:
	cmp.w #5,%d3
	seq %d1
	ext.w %d1
	neg.w %d1
	cmp.w #11,%d2
	sle %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L334
	addq.w #1,%d2
.L350:
	move.w %d2,toolOffset
	jbsr toolRefresh
	jbra .L333
	.even
.L334:
	moveq.l #-10,%d4
.L333:
	move.w #2,-(%sp)
	move.w y,%d1
	move.w %d1,%d0
	lsl.w #1,%d0
	add.w %d1,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	clr.w -(%sp)
	pea .LC55+5
	jbsr show_picvar
	jbra .L329
	.even
.L331:
	moveq.l #-11,%d4
	jbra .L329
	.even
.L337:
	moveq.l #116,%d4
	jbra .L329
	.even
.L338:
	moveq.l #16,%d4
	jbra .L329
	.even
.L340:
	move.w #265,%d4
	jbra .L329
	.even
.L343:
	move.w %d3,%d4
.L329:
	move.w %d4,%d0
.L348:
	movm.l -16(%a6),#0x438
	unlk %a6
	rts
.LC128:
	.ascii " File \0"
.LC129:
	.ascii "Quit\0"
.LC130:
	.ascii " Edit \0"
.LC131:
	.ascii " View \0"
.LC132:
	.ascii "Toggle Rung Numbers\0"
.LC133:
	.ascii "Toggle Grid\0"
.LC134:
	.ascii " Rung \0"
.LC135:
	.ascii " Run \0"
.LC136:
	.ascii "Simulate\0"
.LC137:
	.ascii "Emulate\0"
.LC138:
	.ascii "Settings\240\0"
.LC139:
	.ascii " Help \0"
.LC140:
	.ascii "Help\240\0"
.LC141:
	.ascii "About\240\0"
.LC142:
	.ascii " APPS\0"
.LC143:
	.ascii " Tool:\0"
.LC144:
	.ascii "New Ladder\0"
.LC145:
	.ascii "This will clear the workspace.\0"
.LC146:
	.ascii "          Are you sure?\0"
.LC147:
	.ascii "Not yet implemented!\12\12Send me an email asking me to implement this feature.\12\12My email is kuashio@hotmail.com\12\12\12                                         The Author\0"
.LC148:
	.ascii "w00t!\0"
.LC149:
	.ascii "Delete Rung?\0"
.LC150:
	.ascii "Are you sure you want to\0"
.LC151:
	.ascii "delete this entire Rung?\0"
.LC152:
	.ascii "This will delete the current symbol\0"
.LC153:
	.ascii "delete this symbol?\0"
	.even
exec.87:
	link.w %a6,#-12
	movm.l #0x1f38,-(%sp)
	move.l %a0,-4(%a6)
	move.l 8(%a6),%a3
	move.w 12(%a6),%d7
	move.b 17(%a6),%d6
	move.l %a0,%a2
	clr.w %d4
	move.b %d6,%d3
	jbeq .L445
	cmp.w #10,%d7
	seq %d2
	ext.w %d2
	neg.w %d2
	cmp.w #9,%d7
	seq %d1
	ext.w %d1
	neg.w %d1
	move.w %d7,%d4
	muls.w #14,%d4
	move.w 2(%a3,%d4.l),%d5
	cmp.w #23,%d5
	seq %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	or.w %d1,%d2
	jbeq .L446
	moveq.l #1,%d4
	jbra .L479
	.even
.L446:
	move.w %d5,%d0
	subq.w #7,%d0
	cmp.w #19,%d0
	jbhi .L477
	and.l #0xFFFF,%d0
	add.l %d0,%d0
	.set .LI478,.+2
	move.w .L478-.LI478.b(%pc,%d0.l),%d0
	jmp %pc@(2,%d0:w)
	.even
.L478:
	.word .L451-.L478
	.word .L459-.L478
	.word .L477-.L478
	.word .L477-.L478
	.word .L477-.L478
	.word .L467-.L478
	.word .L470-.L478
	.word .L473-.L478
	.word .L477-.L478
	.word .L477-.L478
	.word .L477-.L478
	.word .L477-.L478
	.word .L477-.L478
	.word .L477-.L478
	.word .L477-.L478
	.word .L450-.L478
	.word .L476-.L478
	.word .L477-.L478
	.word .L477-.L478
	.word .L450-.L478
	.even
.L450:
	subq.l #2,%sp
	move.b 19(%a6),1(%sp)
	subq.l #2,%sp
	move.b %d6,1(%sp)
	move.w 14(%a6),%d0
	subq.w #1,%d0
	move.w %d0,-(%sp)
	move.w %d7,-(%sp)
	move.w %d0,-(%sp)
	jbsr copyRow
	addq.l #2,%sp
	move.l %a0,-(%sp)
	jbra .L483
	.even
.L451:
	move.l 4(%a3,%d4.l),%a0
	move.b (%a0),%d0
	cmp.b #73,%d0
	jbeq .L453
	jbgt .L458
	cmp.b #66,%d0
	jbeq .L455
	jbra .L452
	.even
.L458:
	cmp.b #79,%d0
	jbeq .L454
	jbra .L452
	.even
.L453:
	move.b 2(%a0),%d0
	ext.w %d0
	add.w #-48,%d0
	moveq.l #1,%d1
	lsl.w %d0,%d1
	move.b 19(%a6),%d3
	and.b %d1,%d3
	jbra .L452
	.even
.L454:
	move.b 2(%a0),%d1
	ext.w %d1
	add.w #-48,%d1
	moveq.l #1,%d0
	lsl.w %d1,%d0
	move.b %d0,%d3
	and.b -35(%a2),%d3
	jbra .L452
	.even
.L455:
	move.b 2(%a0),%d1
	ext.w %d1
	add.w #-48,%d1
	moveq.l #1,%d0
	lsl.w %d1,%d0
	move.b %d0,%d3
	and.b -34(%a2),%d3
.L452:
	subq.l #2,%sp
	move.b 19(%a6),1(%sp)
	subq.l #2,%sp
	move.b %d3,1(%sp)
	jbra .L484
	.even
.L459:
	move.l 4(%a3,%d4.l),%a0
	move.b (%a0),%d0
	cmp.b #73,%d0
	jbeq .L461
	jbgt .L466
	cmp.b #66,%d0
	jbeq .L463
	jbra .L460
	.even
.L466:
	cmp.b #79,%d0
	jbeq .L462
	jbra .L460
	.even
.L461:
	move.b 19(%a6),%d1
	ext.w %d1
	jbra .L485
	.even
.L462:
	clr.w %d1
	move.b -35(%a2),%d1
	jbra .L485
	.even
.L463:
	clr.w %d1
	move.b -34(%a2),%d1
.L485:
	move.b 2(%a0),%d0
	ext.w %d0
	add.w #-48,%d0
	asr.w %d0,%d1
	move.b %d1,%d3
	eor.b #1,%d3
	and.b #1,%d3
.L460:
	subq.l #2,%sp
	move.b 19(%a6),1(%sp)
	subq.l #2,%sp
	move.b %d3,1(%sp)
	jbra .L484
	.even
.L467:
	lea (14,%a3),%a1
	tst.w (%a1,%d4.l)
	jbne .L468
	moveq.l #1,%d3
	move.l 4(%a3,%d4.l),%a0
	move.b 2(%a0),%d1
	ext.w %d1
	add.w #-48,%d1
	moveq.l #1,%d0
	lsl.w %d1,%d0
	or.b %d0,-34(%a2)
	jbra .L469
	.even
.L468:
	clr.b %d3
	move.l 4(%a3,%d4.l),%a0
	move.b 2(%a0),%d1
	ext.w %d1
	add.w #-48,%d1
	moveq.l #-2,%d0
	rol.w %d1,%d0
	and.b %d0,-34(%a2)
.L469:
	move.w #1,(%a1,%d4.l)
	subq.l #2,%sp
	move.b 19(%a6),1(%sp)
	subq.l #2,%sp
	move.b %d3,1(%sp)
	jbra .L484
	.even
.L470:
	move.l 4(%a3,%d4.l),%a0
	move.b 2(%a0),%d0
	ext.w %d0
	add.w #-48,%d0
	move.w %d0,%a0
	add.l %a0,%a0
	move.w -32(%a0,%a2.l),-(%sp)
	pea .LC40
	moveq.l #-10,%d3
	add.l %a6,%d3
	move.l %d3,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.l 8(%a3,%d4.l),-(%sp)
	move.l %d3,-(%sp)
	move.l 2500(%a5),%a0
	jsr (%a0)
	lea (18,%sp),%sp
	tst.w %d0
	seq %d0
	subq.l #2,%sp
	move.b 19(%a6),1(%sp)
	neg.b %d0
	subq.l #2,%sp
	move.b %d0,1(%sp)
	jbra .L484
	.even
.L473:
	move.l 4(%a3,%d4.l),%a0
	move.b 2(%a0),%d0
	ext.w %d0
	add.w #-48,%d0
	move.w %d0,%a0
	add.l %a0,%a0
	move.w -16(%a0,%a2.l),-(%sp)
	pea .LC40
	moveq.l #-10,%d3
	add.l %a6,%d3
	move.l %d3,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.l 8(%a3,%d4.l),-(%sp)
	move.l %d3,-(%sp)
	move.l 2500(%a5),%a0
	jsr (%a0)
	lea (18,%sp),%sp
	tst.w %d0
	seq %d0
	subq.l #2,%sp
	move.b 19(%a6),1(%sp)
	neg.b %d0
	subq.l #2,%sp
	move.b %d0,1(%sp)
	jbra .L484
	.even
.L476:
	subq.l #2,%sp
	move.b 19(%a6),1(%sp)
	subq.l #2,%sp
	move.b %d6,1(%sp)
	move.w 14(%a6),-(%sp)
	move.w %d7,%d0
	addq.w #1,%d0
	move.w %d0,-(%sp)
	move.l %a3,-(%sp)
	move.l %a2,%a0
	jbsr exec.87
	move.w %d0,%d4
	subq.l #2,%sp
	move.b 19(%a6),1(%sp)
	subq.l #2,%sp
	move.b %d6,1(%sp)
	move.w 14(%a6),%d0
	addq.w #1,%d0
	move.w %d0,-(%sp)
	move.w %d7,-(%sp)
	move.l 156(%a3),-(%sp)
	move.l %a2,%a0
	jbsr exec.87
	or.w %d0,%d4
	jbra .L479
	.even
.L477:
	subq.l #2,%sp
	move.b 19(%a6),1(%sp)
	subq.l #2,%sp
	move.b %d6,1(%sp)
.L484:
	move.w 14(%a6),-(%sp)
	addq.w #1,%d7
	move.w %d7,-(%sp)
	move.l %a3,-(%sp)
.L483:
	move.l %a2,%a0
	jbsr exec.87
	move.w %d0,%d4
	jbra .L479
	.even
.L445:
	cmp.w #10,%d7
	seq %d2
	ext.w %d2
	neg.w %d2
	cmp.w #9,%d7
	seq %d1
	ext.w %d1
	neg.w %d1
	move.w %d7,%d3
	muls.w #14,%d3
	lea (2,%a3),%a4
	cmp.w #23,(%a4,%d3.l)
	seq %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	or.w %d1,%d2
	jbne .L481
	subq.l #2,%sp
	move.b 19(%a6),1(%sp)
	subq.l #2,%sp
	move.b #0,1(%sp)
	move.w 14(%a6),-(%sp)
	addq.w #1,%d7
	move.w %d7,-(%sp)
	move.l %a3,-(%sp)
	move.l %a2,%a0
	jbsr exec.87
.L481:
	cmp.w #12,(%a4,%d3.l)
	jbne .L479
	clr.w 14(%a3,%d3.l)
.L479:
	move.w %d4,%d0
	movm.l -44(%a6),#0x1cf8
	unlk %a6
	rts
.LC154:
	.ascii "Check your Link connection.\0"
.LC155:
	.ascii "LinkPort Malfunction\0"
.LC156:
	.ascii "Exit Ti-PLC\0"
.LC157:
	.ascii "Are you sure you want to quit?\0"
.LC158:
	.ascii "Preset: \0"
.LC159:
	.ascii "Label: \0"
.LC160:
	.ascii "Comment: \0"
.LC161:
	.ascii "Arrow Tool.  Shortcut Key: MODE\0"
.LC162:
	.ascii "Not Yet Implemented\0"
.LC163:
	.ascii "Add Rung\0"
.LC164:
	.ascii "Add Branch\0"
.LC165:
	.ascii "Delete Tool.  Shortcut Key: CLEAR\0"
.LC166:
	.ascii "To switch to the next tool, press APPS\0"
.LC167:
	.ascii "To switch to the previous tool, press 2nd+APPS\0"
	.even
.globl standby
standby:
	link.w %a6,#-120
	movm.l #0x1f38,-(%sp)
	sub.l %a4,%a4
	clr.b -117(%a6)
	move.w %a4,-120(%a6)
	move.w #18,-(%sp)
	move.w #240,-(%sp)
	move.w #2,-(%sp)
	move.l 268(%a5),%a0
	jsr (%a0)
	move.w %d0,-116(%a6)
	move.w %a4,-(%sp)
	move.w #1,-(%sp)
	pea .LC128
	move.w %a4,-(%sp)
	move.w %d0,-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	move.w %a4,-(%sp)
	move.w #16,-(%sp)
	pea .LC129
	move.w #1,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	move.w %a4,-(%sp)
	move.w #2,-(%sp)
	pea .LC130
	move.w %a4,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	lea (42,%sp),%sp
	move.w %a4,-(%sp)
	move.w #3,-(%sp)
	pea .LC131
	move.w %a4,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	move.w %a4,-(%sp)
	move.w #32,-(%sp)
	pea .LC132
	move.w #3,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	move.w %a4,-(%sp)
	move.w #35,-(%sp)
	pea .LC133
	move.w #3,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	lea (36,%sp),%sp
	move.w %a4,-(%sp)
	move.w #4,-(%sp)
	pea .LC134
	move.w %a4,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	move.w %a4,-(%sp)
	move.w #5,-(%sp)
	pea .LC135
	move.w %a4,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	move.w %a4,-(%sp)
	move.w #51,-(%sp)
	pea .LC136
	move.w #5,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	lea (36,%sp),%sp
	move.w %a4,-(%sp)
	move.w #52,-(%sp)
	pea .LC137
	move.w #5,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	move.w %a4,-(%sp)
	move.w #54,-(%sp)
	pea .LC138
	move.w #5,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	move.w %a4,-(%sp)
	move.w #6,-(%sp)
	pea .LC139
	move.w %a4,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	lea (36,%sp),%sp
	move.w %a4,-(%sp)
	move.w #61,-(%sp)
	pea .LC140
	move.w #6,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	move.w %a4,-(%sp)
	move.w #62,-(%sp)
	pea .LC141
	move.w #6,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 260(%a5),%a0
	jsr (%a0)
	move.w %a4,-(%sp)
	move.w %a4,-(%sp)
	move.w %a4,-(%sp)
	move.w -116(%a6),-(%sp)
	move.l 612(%a5),%a0
	jsr (%a0)
	addq.l #2,%sp
	move.l %a0,-(%sp)
	move.l 216(%a5),%a0
	jsr (%a0)
	move.w %d0,-114(%a6)
	lea (34,%sp),%sp
	.even
.L354:
	move.w #1,-(%sp)
	pea .LC142
	move.w #2,-(%sp)
	move.w #122,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	move.w #1,-(%sp)
	pea .LC143
	move.w #9,-(%sp)
	move.w #122,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	move.w #4,-(%sp)
	move.w #2,-(%sp)
	move.w #145,-(%sp)
	pea .LC56+6
	lea show_picvar,%a2
	jsr (%a2)
	move.w #4,-(%sp)
	move.w #2,-(%sp)
	move.w #145,-(%sp)
	move.w %a4,%d0
	ext.l %d0
	lsl.l #2,%d0
	lea tools,%a3
	move.l (%a3,%d0.l),-(%sp)
	jsr (%a2)
	lea (40,%sp),%sp
	move.l 324(%a5),%a0
	jsr (%a0)
	move.w %d0,%d1
	add.w #-268,%d0
	cmp.w #5,%d0
	jbhi .L355
	move.w %d1,-(%sp)
	move.w -114(%a6),-(%sp)
	move.l 228(%a5),%a0
	jsr (%a0)
	move.w %d0,%d7
	addq.l #4,%sp
	jbra .L356
	.even
.L355:
	move.w %d1,-(%sp)
	jbsr keyAction
	move.w %d0,%d7
	addq.l #2,%sp
.L356:
	tst.w %d7
	jbeq .L357
	cmp.w #54,%d7
	jbeq .L367
	jbgt .L574
	cmp.w #32,%d7
	jbeq .L365
	jbgt .L575
	cmp.w #-10,%d7
	jbeq .L370
	jbgt .L576
	cmp.w #-11,%d7
	jbeq .L376
	jbra .L357
	.even
.L576:
	cmp.w #16,%d7
	jbeq .L570
	jbra .L357
	.even
.L575:
	cmp.w #51,%d7
	jbeq .L443
	jbgt .L577
	cmp.w #35,%d7
	jbeq .L366
	jbra .L357
	.even
.L577:
	cmp.w #52,%d7
	jbeq .L442
	jbra .L357
	.even
.L574:
	cmp.w #263,%d7
	jbeq .L362
	jbgt .L578
	cmp.w #62,%d7
	jbeq .L369
	jbgt .L579
	cmp.w #61,%d7
	jbeq .L368
	jbra .L357
	.even
.L579:
	cmp.w #116,%d7
	jbeq .L568
	jbra .L357
	.even
.L578:
	cmp.w #266,%d7
	jbeq .L359
	jbgt .L580
	cmp.w #265,%d7
	jbeq .L360
	jbra .L357
	.even
.L580:
	cmp.w #4361,%d7
	jbeq .L363
	jbra .L357
	.even
.L359:
	move.w #17,%a4
.L360:
	addq.w #1,%a4
	moveq.l #18,%d0
	cmp.w %a4,%d0
	jbne .L364
	sub.l %a4,%a4
	jbra .L364
	.even
.L362:
	move.w #7,%a4
.L363:
	subq.w #1,%a4
	cmp.w #-1,%a4
	jbne .L364
	move.w #17,%a4
.L364:
	move.w #4,-(%sp)
	move.w #2,-(%sp)
	move.w #145,-(%sp)
	pea .LC56+6
	jsr (%a2)
	move.w #4,-(%sp)
	move.w #2,-(%sp)
	move.w #145,-(%sp)
	move.w %a4,%d0
	ext.l %d0
	lsl.l #2,%d0
	move.l (%a3,%d0.l),-(%sp)
	jsr (%a2)
	lea (20,%sp),%sp
	jbra .L357
	.even
.L365:
	tst.w showRungs
	seq %d0
	ext.w %d0
	neg.w %d0
	move.w %d0,showRungs
.L626:
	jbsr refresh
	jbra .L357
	.even
.L366:
	tst.w showGrid
	seq %d0
	ext.w %d0
	neg.w %d0
	move.w %d0,showGrid
	jbsr grid
	jbra .L357
	.even
.L367:
	jbsr settings
	jbra .L357
	.even
.L368:
	jbsr help
	jbra .L357
	.even
.L369:
	jbsr about
	jbra .L357
	.even
.L370:
	move.w y,%d2
	seq %d1
	ext.w %d1
	neg.w %d1
	move.w toolOffset,%d3
	seq %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L371
	sub.l %a4,%a4
.L371:
	cmp.w #5,%d2
	seq %d1
	ext.w %d1
	neg.w %d1
	cmp.w #12,%d3
	seq %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L372
	move.w #17,%a4
.L372:
	move.w %d2,%d0
	subq.w #1,%d0
	cmp.w #3,%d0
	jbhi .L373
	move.w %d3,%a4
	add.w %d2,%a4
.L373:
	move.w %a4,%d0
	subq.w #1,%d0
	cmp.w #2,%d0
	jbhi .L374
	moveq.l #-11,%d7
.L374:
	jbsr toolRefresh
	move.w #2,-(%sp)
	move.w y,%d1
	move.w %d1,%d0
	lsl.w #1,%d0
	add.w %d1,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	clr.w -(%sp)
	pea .LC55+5
	jsr (%a2)
	lea (10,%sp),%sp
	cmp.w #-10,%d7
	jbeq .L357
.L376:
	moveq.l #6,%d1
	cmp.w %a4,%d1
	jbcs .L434
	clr.l %d0
	move.w %a4,%d0
	add.l %d0,%d0
	.set .LI441,.+2
	move.w .L441-.LI441.b(%pc,%d0.l),%d0
	jmp %pc@(2,%d0:w)
	.even
.L441:
	.word .L378-.L441
	.word .L380-.L441
	.word .L393-.L441
	.word .L393-.L441
	.word .L394-.L441
	.word .L397-.L441
	.word .L404-.L441
	.even
.L378:
	move.w y,%d2
	add.w winOffset,%d2
	move.w %d2,-(%sp)
	jbsr copyRow
	move.w x,%d0
	muls.w #14,%d0
	move.w 2(%a0,%d0.l),%d0
	addq.l #2,%sp
	cmp.w #19,%d0
	sle %d1
	ext.w %d1
	neg.w %d1
	cmp.w #21,%d0
	seq %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	move.w y,%d2
	move.w %d2,%d0
	add.w winOffset,%d0
	cmp.w entries.l,%d0
	slt %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	not.w %d2
	moveq.l #15,%d0
	lsr.w %d0,%d2
	and.w %d2,%d1
	jbeq .L357
	jbsr properties
	jbra .L357
	.even
.L380:
	pea NoCallBack
	move.w #55,-(%sp)
	move.w #140,-(%sp)
	move.l 208(%a5),%a0
	jsr (%a0)
	move.w %d0,%d5
	move.w #5,-(%sp)
	move.w #3,-(%sp)
	pea .LC144
	move.w #8,-(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC145
	move.w #7,-(%sp)
	move.w #20,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (36,%sp),%sp
	move.l #.LC146,(%sp)
	move.w #7,-(%sp)
	move.w #27,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	clr.l -(%sp)
	clr.l -(%sp)
	move.w #-1,-(%sp)
	move.w #-1,-(%sp)
	move.w %d5,-(%sp)
	move.l 200(%a5),%a0
	jsr (%a0)
	lea (28,%sp),%sp
	cmp.w #13,%d0
	jbne .L381
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	sub.l %a4,%a4
	move.w %a4,toolOffset
	addq.l #2,%sp
	move.w entries,%d0
	jbne .L611
	tst.l ladder
	jbeq .L382
	jbra .L611
	.even
.L386:
	move.l ladder,%a2
	jbra .L612
	.even
.L389:
	move.l 156(%a2),%a2
.L612:
	move.l 156(%a2),%a0
	tst.l 156(%a0)
	jbne .L389
	move.l 156(%a2),-(%sp)
	move.l 652(%a5),%a0
	jsr (%a0)
	clr.l 156(%a2)
	move.w entries,%d0
	move.w %d0,%d1
	subq.w #1,%d1
	move.w %d1,entries
	addq.l #4,%sp
	subq.w #1,%d0
.L611:
	cmp.w #1,%d0
	jbgt .L386
	move.l ladder,-(%sp)
	move.l 652(%a5),%a0
	jsr (%a0)
	addq.l #4,%sp
.L382:
	clr.l ladder
	clr.w entries
	move.w #-1,y
	move.w #-2,x
	jbsr refresh
.L381:
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	move.w %d5,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	addq.l #4,%sp
	jbra .L357
	.even
.L393:
	clr.w -(%sp)
	move.w #1,-(%sp)
	pea .LC147
	pea .LC148
	move.l 1744(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	lea (14,%sp),%sp
	jbra .L357
	.even
.L394:
	move.w y,%d2
	add.w winOffset,%d2
	move.w %d2,-(%sp)
	lea copyRow,%a2
	jsr (%a2)
	addq.l #2,%sp
	cmp.w #21,2(%a0)
	jbeq .L396
	move.w y,%d0
	add.w winOffset,%d0
	cmp.w entries.l,%d0
	jblt .L357
.L396:
	move.w y,%d0
	add.w winOffset,%d0
	move.w %d0,-(%sp)
	jsr (%a2)
	move.l %a0,-(%sp)
	jbsr insertRung
	jbsr refresh
	addq.l #6,%sp
	jbra .L357
	.even
.L397:
	move.w y,%d1
	add.w winOffset,%d1
	move.w %d1,-(%sp)
	lea copyRow,%a2
	jsr (%a2)
	move.w x,%d1
	move.w %d1,%d0
	muls.w #14,%d0
	addq.l #2,%sp
	cmp.w #20,2(%a0,%d0.l)
	jbeq .L399
	cmp.w #9,%d1
	jbgt .L357
.L399:
	tst.b -117(%a6)
	jbeq .L400
	move.b -117(%a6),%d2
	ext.w %d2
	move.w %d2,%d0
	addq.w #1,%d0
	cmp.w %d1,%d0
	jbge .L400
	move.w %d2,-(%sp)
	move.w y,%d2
	add.w winOffset,%d2
	move.w %d2,-(%sp)
	jbra .L613
	.even
.L400:
	cmp.b #9,-117(%a6)
	jbne .L402
	move.w #9,-(%sp)
	move.w y,%d0
	add.w winOffset,%d0
	move.w %d0,-(%sp)
.L613:
	jsr (%a2)
	addq.l #2,%sp
	move.l %a0,-(%sp)
	jbsr insertBranch
	clr.b -117(%a6)
	addq.l #6,%sp
	jbra .L626
	.even
.L402:
	move.b x+1,-117(%a6)
	jbra .L626
	.even
.L404:
	move.w y,%d1
	add.w winOffset,%d1
	move.w %d1,-(%sp)
	jbsr copyRow
	addq.l #2,%sp
	tst.w x
	seq %d1
	ext.w %d1
	neg.w %d1
	move.w y,%d0
	add.w winOffset,%d0
	cmp.w entries.l,%d0
	slt %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	cmp.w #21,2(%a0)
	seq %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L405
	pea NoCallBack
	move.w #55,-(%sp)
	move.w #140,-(%sp)
	move.l 208(%a5),%a0
	jsr (%a0)
	move.w %d0,%d5
	move.w #5,-(%sp)
	move.w #3,-(%sp)
	pea .LC149
	move.w #8,-(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC150
	move.w #7,-(%sp)
	move.w #20,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (36,%sp),%sp
	move.l #.LC151,(%sp)
	move.w #7,-(%sp)
	move.w #27,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	clr.l -(%sp)
	clr.l -(%sp)
	move.w #-1,-(%sp)
	move.w #-1,-(%sp)
	move.w %d5,-(%sp)
	move.l 200(%a5),%a0
	jsr (%a0)
	lea (28,%sp),%sp
	cmp.w #13,%d0
	jbne .L406
	move.l ladder,%a2
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	addq.l #2,%sp
	cmp.w #0,%a2
	jbeq .L357
	move.w entries,%d6
	cmp.w #1,%d6
	jbne .L408
	move.l %a2,-(%sp)
	move.l 652(%a5),%a0
	jsr (%a0)
	clr.l ladder
	subq.w #1,entries
	addq.l #4,%sp
	jbra .L617
	.even
.L408:
	clr.w %d3
	move.w winOffset,%d4
	move.w %d4,%d2
	subq.w #1,%d2
	move.w y,%d1
	jbra .L615
	.even
.L413:
	move.l 156(%a2),%a2
	addq.w #1,%d3
.L615:
	move.w %d1,%d0
	add.w %d2,%d0
	cmp.w %d3,%d0
	jbgt .L413
	add.w %d4,%d1
	seq %d1
	ext.w %d1
	neg.w %d1
	tst.w %d6
	sgt %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L616
	move.l 156(%a2),%a0
	cmp.w #0,%a0
	jbeq .L417
	move.w (%a2),%d2
	cmp.w (%a0),%d2
	jbne .L417
	.even
.L418:
	move.l ladder,%a0
	move.l 156(%a0),ladder
	move.l %a2,-(%sp)
	move.l 652(%a5),%a0
	jsr (%a0)
	move.l ladder,%a2
	subq.w #1,entries
	addq.l #4,%sp
	move.l 156(%a2),%a0
	cmp.w #0,%a0
	jbeq .L417
	move.w (%a2),%d0
	cmp.w (%a0),%d0
	jbeq .L418
.L417:
	move.l ladder,%a0
	move.l 156(%a0),ladder
	move.l %a2,-(%sp)
	move.l 652(%a5),%a0
	jsr (%a0)
	subq.w #1,entries
	addq.l #4,%sp
	jbra .L629
	.even
.L424:
	move.l 156(%a0),156(%a2)
	move.l %a0,-(%sp)
	move.l 652(%a5),%a0
	jsr (%a0)
	subq.w #1,entries
	addq.l #4,%sp
.L616:
	move.l 156(%a2),%a0
	cmp.w #0,%a0
	jbeq .L629
	move.w (%a2),%d0
	addq.w #1,%d0
	cmp.w (%a0),%d0
	jbeq .L424
	jbra .L629
	.even
.L429:
	cmp.w #21,2(%a2)
	jbne .L430
	pea .LC39
	moveq.l #-60,%d4
	add.l %a6,%d4
	move.l %d4,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w (%a2),-(%sp)
	pea .LC40
	moveq.l #-40,%d3
	add.l %a6,%d3
	move.l %d3,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.l %d3,-(%sp)
	move.l %d4,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	move.l 8(%a2),-(%sp)
	move.l %d4,-(%sp)
	move.l 2500(%a5),%a0
	jsr (%a0)
	lea (34,%sp),%sp
	tst.w %d0
	jbne .L430
	pea .LC39
	move.l %d4,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w (%a2),%d1
	addq.w #1,%d1
	move.w %d1,-(%sp)
	pea .LC40
	move.l %d3,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.l %d3,-(%sp)
	move.l %d4,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	pea 20.w
	move.l 648(%a5),%a0
	jsr (%a0)
	move.l %a0,8(%a2)
	move.l %d4,-(%sp)
	move.l %a0,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	lea (38,%sp),%sp
.L430:
	subq.w #1,(%a2)
.L629:
	move.l 156(%a2),%a2
.L617:
	cmp.w #0,%a2
	jbne .L429
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	move.w %d5,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	jbsr refresh
	addq.l #4,%sp
.L406:
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	jbra .L618
	.even
.L405:
	move.w #20,%a4
.L434:
	move.w y,%d2
	add.w winOffset,%d2
	move.w %d2,-(%sp)
	jbsr copyRow
	move.w x,%d2
	move.w %d2,%d0
	muls.w #14,%d0
	lea 2(%a0,%d0.l),%a2
	move.w (%a2),%d0
	addq.l #2,%sp
	cmp.w #-1,%d0
	jbeq .L435
	cmp.w #20,%d0
	jbgt .L435
	move.w y,%d0
	add.w winOffset,%d0
	cmp.w entries.l,%d0
	jbge .L435
	moveq.l #17,%d0
	cmp.w %a4,%d0
	sne %d1
	ext.w %d1
	neg.w %d1
	cmp.w #1,%d2
	seq %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	jbeq .L435
	moveq.l #9,%d1
	cmp.w %a4,%d1
	sne %d1
	ext.w %d1
	neg.w %d1
	cmp.w #10,%d2
	seq %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	jbeq .L435
	moveq.l #10,%d0
	cmp.w %a4,%d0
	sne %d1
	ext.w %d1
	neg.w %d1
	cmp.w #10,%d2
	seq %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	jbeq .L435
	moveq.l #11,%d1
	cmp.w %a4,%d1
	sne %d1
	ext.w %d1
	neg.w %d1
	cmp.w #10,%d2
	seq %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	jbeq .L435
	moveq.l #15,%d0
	cmp.w %a4,%d0
	sne %d1
	ext.w %d1
	neg.w %d1
	cmp.w #10,%d2
	seq %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	jbeq .L435
	moveq.l #16,%d1
	cmp.w %a4,%d1
	sne %d1
	ext.w %d1
	neg.w %d1
	cmp.w #10,%d2
	seq %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	jbeq .L435
	moveq.l #7,%d0
	cmp.w %a4,%d0
	sne %d1
	ext.w %d1
	neg.w %d1
	cmp.w #10,%d2
	sne %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	jbeq .L435
	moveq.l #8,%d1
	cmp.w %a4,%d1
	sne %d1
	ext.w %d1
	neg.w %d1
	cmp.w #10,%d2
	sne %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	jbeq .L435
	moveq.l #12,%d0
	cmp.w %a4,%d0
	sne %d1
	ext.w %d1
	neg.w %d1
	cmp.w #10,%d2
	sne %d0
	ext.w %d0
	neg.w %d0
	or.w %d0,%d1
	jbeq .L435
	pea NoCallBack
	move.w #55,-(%sp)
	move.w #140,-(%sp)
	move.l 208(%a5),%a0
	jsr (%a0)
	move.w %d0,%d5
	move.w #5,-(%sp)
	move.w #3,-(%sp)
	pea .LC152
	move.w #8,-(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC150
	move.w #7,-(%sp)
	move.w #20,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (36,%sp),%sp
	move.l #.LC153,(%sp)
	move.w #7,-(%sp)
	move.w #27,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (14,%sp),%sp
	cmp.w #20,(%a2)
	jbeq .L437
	clr.l -(%sp)
	clr.l -(%sp)
	move.w #-1,-(%sp)
	move.w #-1,-(%sp)
	move.w %d5,-(%sp)
	move.l 200(%a5),%a0
	jsr (%a0)
	lea (14,%sp),%sp
	cmp.w #13,%d0
	jbne .L436
.L437:
	move.w #2,-(%sp)
	move.w y,%d1
	move.w %d1,%d0
	lsl.w #1,%d0
	add.w %d1,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	move.w x,%d1
	move.w %d1,%d0
	lsl.w #1,%d0
	add.w %d1,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	pea .LC55+5
	lea show_picvar,%a2
	jsr (%a2)
	move.w #4,-(%sp)
	move.w y,%d1
	move.w %d1,%d0
	lsl.w #1,%d0
	add.w %d1,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	move.w x,%d1
	move.w %d1,%d0
	lsl.w #1,%d0
	add.w %d1,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	move.w %a4,%d0
	ext.l %d0
	lsl.l #2,%d0
	move.l (%a3,%d0.l),-(%sp)
	jsr (%a2)
	lea (20,%sp),%sp
	tst.w showGrid
	jbeq .L438
	move.w #1,-(%sp)
	move.w y,%d1
	move.w %d1,%d0
	lsl.w #1,%d0
	add.w %d1,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	move.w x,%d1
	move.w %d1,%d0
	lsl.w #1,%d0
	add.w %d1,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	move.l 1696(%a5),%a0
	jsr (%a0)
	addq.l #6,%sp
.L438:
	move.w %a4,-(%sp)
	jbsr insertCell
	move.w #2,-(%sp)
	move.w y,%d1
	move.w %d1,%d0
	lsl.w #1,%d0
	add.w %d1,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	move.w x,%d1
	move.w %d1,%d0
	lsl.w #1,%d0
	add.w %d1,%d0
	lsl.w #2,%d0
	add.w #18,%d0
	move.w %d0,-(%sp)
	pea .LC55+5
	jsr (%a2)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	lea (14,%sp),%sp
	moveq.l #20,%d1
	cmp.w %a4,%d1
	jbeq .L439
	jbsr properties
.L439:
	jbsr refresh
.L436:
	move.w %d5,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	addq.l #4,%sp
.L435:
	moveq.l #20,%d2
	cmp.w %a4,%d2
	jbne .L357
	move.w #6,%a4
	jbra .L357
	.even
.L442:
	move.w #1,-120(%a6)
.L443:
	clr.b %d6
	clr.w -112(%a6)
	jbsr clrscr
	clr.b -36(%a6)
	clr.b -35(%a6)
	clr.b -34(%a6)
	clr.w %d0
	.even
.L489:
	move.w %d0,%a0
	add.l %a0,%a0
	lea (-32,%a6),%a1
	clr.w (%a0,%a1.l)
	lea (-16,%a6),%a2
	clr.w (%a0,%a2.l)
	addq.w #1,%d0
	cmp.w #7,%d0
	jble .L489
	clr.l %d0
	move.b watchIndex,%d0
	add.l %d0,%d0
	move.w (%a1,%d0.l),watch
	clr.l %d0
	move.b watchIndex+1,%d0
	add.l %d0,%d0
	move.w (%a1,%d0.l),watch+2
	clr.l %d0
	move.b watchIndex+2,%d0
	add.l %d0,%d0
	move.w (%a2,%d0.l),watch+4
	clr.l %d0
	move.b watchIndex+3,%d0
	add.l %d0,%d0
	move.w (%a2,%d0.l),watch+6
	jbsr drawPLC
	subq.l #2,%sp
	move.b -34(%a6),1(%sp)
	subq.l #2,%sp
	move.b -35(%a6),1(%sp)
	jbra .L619
	.even
.L496:
	move.l %d3,-(%sp)
	pea -112(%a6)
	move.l 3752(%a5),%a0
	jsr (%a0)
	addq.l #8,%sp
	jbra .L497
	.even
.L494:
	move.l %d3,-(%sp)
	pea -112(%a6)
	move.l 3752(%a5),%a0
	jsr (%a0)
	addq.l #8,%sp
	tst.w %d0
	jbne .L497
	move.b -111(%a6),%d1
	add.b #-48,%d1
	move.b -36(%a6),%d2
	cmp.b #7,%d1
	jbhi .L497
	ext.w %d1
	moveq.l #1,%d0
	lsl.w %d1,%d0
	eor.b %d0,%d2
	move.b %d2,-36(%a6)
.L497:
	cmp.w #264,-112(%a6)
	jbeq .L492
	move.l ladder,%a2
	clr.w %d5
.L625:
	cmp.w #0,%a2
	jbeq .L502
	moveq.l #1,%d4
	move.w (%a2),%a3
	subq.l #2,%sp
	move.b -36(%a6),1(%sp)
	subq.l #2,%sp
	move.b #1,1(%sp)
	move.w %d5,-(%sp)
	move.w %d4,-(%sp)
	move.l %a2,-(%sp)
	move.l %a6,%a0
	jbsr exec.87
	move.w %d0,%d3
	lea (12,%sp),%sp
	.even
.L558:
	move.w 142(%a2),%d0
	add.w #-9,%d0
	cmp.w #7,%d0
	jbhi .L507
	and.l #0xFFFF,%d0
	add.l %d0,%d0
	.set .LI557,.+2
	move.w .L557-.LI557.b(%pc,%d0.l),%d0
	jmp %pc@(2,%d0:w)
	.even
.L557:
	.word .L508-.L557
	.word .L518-.L557
	.word .L526-.L557
	.word .L507-.L557
	.word .L534-.L557
	.word .L541-.L557
	.word .L545-.L557
	.word .L549-.L557
	.even
.L508:
	move.l 144(%a2),%a0
	move.b (%a0),%d0
	cmp.b #66,%d0
	jbeq .L513
	cmp.b #79,%d0
	jbne .L507
	tst.w %d3
	jbne .L620
	jbra .L621
	.even
.L513:
	tst.w %d3
	jbne .L622
	jbra .L623
	.even
.L518:
	move.l 144(%a2),%a0
	move.b (%a0),%d0
	cmp.b #66,%d0
	jbeq .L522
	cmp.b #79,%d0
	jbne .L507
	tst.w %d3
	jbeq .L507
.L620:
	move.b 2(%a0),%d1
	ext.w %d1
	add.w #-48,%d1
	moveq.l #1,%d0
	lsl.w %d1,%d0
	or.b %d0,%d6
	jbra .L507
	.even
.L522:
	tst.w %d3
	jbeq .L507
.L622:
	move.b 2(%a0),%d1
	ext.w %d1
	add.w #-48,%d1
	moveq.l #1,%d0
	lsl.w %d1,%d0
	or.b %d0,-34(%a6)
	jbra .L507
	.even
.L526:
	move.l 144(%a2),%a0
	move.b (%a0),%d0
	cmp.b #66,%d0
	jbeq .L530
	cmp.b #79,%d0
	jbne .L507
	tst.w %d3
	jbeq .L507
.L621:
	move.b 2(%a0),%d1
	ext.w %d1
	add.w #-48,%d1
	moveq.l #-2,%d0
	rol.w %d1,%d0
	and.b %d0,%d6
	jbra .L507
	.even
.L530:
	tst.w %d3
	jbeq .L507
.L623:
	move.b 2(%a0),%d1
	ext.w %d1
	add.w #-48,%d1
	moveq.l #-2,%d0
	rol.w %d1,%d0
	and.b %d0,-34(%a6)
	jbra .L507
	.even
.L534:
	tst.w 154(%a2)
	jbne .L535
	btst #0,%d3
	jbeq .L535
	tst.w 152(%a2)
	jbeq .L538
	move.l 144(%a2),%a0
	addq.l #2,%a0
	move.b (%a0),%d0
	ext.w %d0
	add.w #-48,%d0
	move.w %d0,%a0
	add.l %a0,%a0
	subq.w #1,-32(%a0,%a6.l)
	jbra .L539
	.even
.L538:
	move.l 144(%a2),%a0
	addq.l #2,%a0
	move.b (%a0),%d0
	ext.w %d0
	add.w #-48,%d0
	move.w %d0,%a0
	add.l %a0,%a0
	addq.w #1,-32(%a0,%a6.l)
.L539:
	move.w #1,154(%a2)
.L535:
	tst.w %d3
	jbne .L507
	clr.w 154(%a2)
	jbra .L507
	.even
.L541:
	tst.w %d3
	jbeq .L542
	move.l 144(%a2),%a0
	addq.l #2,%a0
	move.b (%a0),%d0
	ext.w %d0
	add.w #-48,%d0
	move.w %d0,%a0
	add.l %a0,%a0
	addq.w #1,-16(%a0,%a6.l)
	jbra .L507
	.even
.L542:
	tst.w 152(%a2)
	jbne .L507
	move.l 144(%a2),%a0
	addq.l #2,%a0
	move.b (%a0),%d0
	jbra .L624
	.even
.L545:
	tst.w %d3
	jbeq .L507
	move.l 144(%a2),%a0
	cmp.b #67,(%a0)
	jbne .L547
	move.b 2(%a0),%d0
	ext.w %d0
	add.w #-48,%d0
	move.w %d0,%a0
	add.l %a0,%a0
	clr.w -32(%a0,%a6.l)
.L547:
	move.l 144(%a2),%a0
	cmp.b #84,(%a0)
	jbne .L507
	move.b 2(%a0),%d0
.L624:
	ext.w %d0
	add.w #-48,%d0
	move.w %d0,%a0
	add.l %a0,%a0
	clr.w -16(%a0,%a6.l)
	jbra .L507
	.even
.L549:
	tst.w %d3
	jbeq .L507
	move.l 148(%a2),-(%sp)
	moveq.l #-60,%d4
	add.l %a6,%d4
	move.l %d4,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.l ladder,%a2
	addq.l #8,%sp
	jbra .L551
	.even
.L553:
	move.l 156(%a2),%a2
	addq.w #1,%d5
.L551:
	cmp.w #0,%a2
	jbeq .L552
	cmp.w #17,16(%a2)
	jbne .L553
	move.l 22(%a2),-(%sp)
	move.l %d4,-(%sp)
	move.l 2500(%a5),%a0
	jsr (%a0)
	addq.l #8,%sp
	tst.w %d0
	jbne .L553
.L552:
	clr.w %d4
.L507:
	move.l 156(%a2),%a2
	addq.w #1,%d5
	move.w 128(%a2),%d0
	cmp.w #21,%d0
	jbeq .L560
	cmp.w #25,%d0
	jbne .L505
.L560:
	tst.w %d4
	jbne .L558
.L505:
	cmp.w #0,%a2
	jbeq .L502
	move.w %a3,%d0
	cmp.w (%a2),%d0
	jbne .L625
	tst.w %d4
	jbeq .L625
	.even
.L563:
	move.l 156(%a2),%a2
	addq.w #1,%d5
	cmp.w #0,%a2
	jbeq .L502
	move.w %a3,%d1
	cmp.w (%a2),%d1
	jbne .L625
	tst.w %d4
	jbne .L563
	jbra .L625
	.even
.L502:
	move.b %d6,-35(%a6)
	clr.l %d0
	move.b watchIndex,%d0
	add.l %d0,%d0
	lea (-32,%a6),%a0
	move.w (%a0,%d0.l),watch
	clr.l %d0
	move.b watchIndex+1,%d0
	add.l %d0,%d0
	move.w (%a0,%d0.l),watch+2
	clr.l %d0
	move.b watchIndex+2,%d0
	add.l %d0,%d0
	lea (-16,%a6),%a0
	move.w (%a0,%d0.l),watch+4
	clr.l %d0
	move.b watchIndex+3,%d0
	add.l %d0,%d0
	move.w (%a0,%d0.l),watch+6
	subq.l #2,%sp
	move.b -34(%a6),1(%sp)
	subq.l #2,%sp
	move.b %d6,1(%sp)
.L619:
	subq.l #2,%sp
	move.b -36(%a6),1(%sp)
	jbsr flush
	addq.l #6,%sp
	cmp.w #264,-112(%a6)
	jbeq .L492
	jbsr kbd_queue
	move.l %a0,%d3
	tst.w -120(%a6)
	jbeq .L494
	move.w #1,-112(%a6)
	subq.l #2,%sp
	move.b -35(%a6),1(%sp)
	jbsr stampLink
	addq.l #2,%sp
	tst.w %d0
	jbeq .L495
	move.b SerialDataRx,-36(%a6)
	jbra .L496
	.even
.L495:
	clr.w -(%sp)
	move.w #1,-(%sp)
	pea .LC154
	pea .LC155
	move.l 1744(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	lea (14,%sp),%sp
.L492:
	jbsr refresh
	clr.w -120(%a6)
	jbra .L357
	.even
.L568:
	cmp.w #-5,x.l
	sgt %d1
	ext.w %d1
	move.w y,%d0
	not.w %d0
	moveq.l #15,%d2
	lsr.w %d2,%d0
	and.w %d1,%d0
	jbeq .L569
	move.w #-5,x
	move.w #-1,y
	jbra .L626
	.even
.L569:
	moveq.l #16,%d7
.L570:
	pea NoCallBack
	move.w #55,-(%sp)
	move.w #140,-(%sp)
	move.l 208(%a5),%a0
	jsr (%a0)
	move.w %d0,%d5
	move.w #5,-(%sp)
	move.w #3,-(%sp)
	pea .LC156
	move.w #8,-(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	pea .LC157
	move.w #7,-(%sp)
	move.w #20,-(%sp)
	move.w #3,-(%sp)
	clr.w -(%sp)
	move.w %d5,-(%sp)
	move.l 204(%a5),%a0
	jsr (%a0)
	lea (36,%sp),%sp
	clr.l (%sp)
	clr.l -(%sp)
	move.w #-1,-(%sp)
	move.w #-1,-(%sp)
	move.w %d5,-(%sp)
	move.l 200(%a5),%a0
	jsr (%a0)
	lea (14,%sp),%sp
	cmp.w #264,%d0
	jbne .L571
	clr.w %d7
	move.w %d7,-(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	addq.l #2,%sp
.L571:
	move.w %d5,-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
.L618:
	addq.l #2,%sp
.L357:
	moveq.l #94,%d3
	.even
.L584:
	clr.w -(%sp)
	move.w %d3,-(%sp)
	move.w #160,-(%sp)
	move.w %d3,-(%sp)
	clr.w -(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	lea (10,%sp),%sp
	addq.w #1,%d3
	cmp.w #99,%d3
	jble .L584
	tst.w entries
	jbeq .L586
	move.w y,%d0
	add.w winOffset,%d0
	move.w %d0,-(%sp)
	jbsr copyRow
	move.l %a0,%a3
	move.w x,%d0
	addq.l #2,%sp
	jble .L586
	muls.w #14,%d0
	lea (2,%a3),%a2
	move.w (%a2,%d0.l),%d0
	cmp.w #19,%d0
	sle %d1
	ext.w %d1
	neg.w %d1
	cmp.w #-1,%d0
	sne %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	move.w y,%d0
	add.w winOffset,%d0
	cmp.w entries.l,%d0
	slt %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L586
	move.w #4,-(%sp)
	pea .LC100
	move.w #95,-(%sp)
	move.w #1,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	move.w #4,-(%sp)
	move.w x,%d0
	muls.w #14,%d0
	move.w (%a2,%d0.l),%d0
	subq.w #7,%d0
	ext.l %d0
	lsl.l #2,%d0
	lea symbolName,%a0
	move.l (%a0,%d0.l),-(%sp)
	move.w #95,-(%sp)
	move.w #29,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	move.w #4,-(%sp)
	move.w #100,-(%sp)
	move.w #46,-(%sp)
	move.w #94,-(%sp)
	move.w #46,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	move.w #4,-(%sp)
	pea .LC101
	move.w #95,-(%sp)
	move.w #48,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	lea (40,%sp),%sp
	move.w #4,-(%sp)
	move.w x,%d0
	muls.w #14,%d0
	move.l 4(%a3,%d0.l),-(%sp)
	move.w #95,-(%sp)
	move.w #77,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	move.w #4,-(%sp)
	move.w #100,-(%sp)
	move.w #91,-(%sp)
	move.w #94,-(%sp)
	move.w #91,-(%sp)
	move.l 1692(%a5),%a0
	jsr (%a0)
	move.w x,%d2
	move.w %d2,%d0
	muls.w #14,%d0
	move.w (%a2,%d0.l),%d3
	move.w %d3,%d0
	add.w #-13,%d0
	lea (20,%sp),%sp
	cmp.w #1,%d0
	sls %d1
	ext.w %d1
	neg.w %d1
	cmp.w #9,%d2
	sle %d0
	ext.w %d0
	neg.w %d0
	and.w %d0,%d1
	jbeq .L588
	move.w #4,-(%sp)
	pea .LC158
	move.w #95,-(%sp)
	move.w #93,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	move.w #4,-(%sp)
	move.w x,%d0
	muls.w #14,%d0
	move.l 8(%a3,%d0.l),-(%sp)
	move.w #95,-(%sp)
	move.w #118,-(%sp)
	jbra .L627
	.even
.L588:
	add.w #-16,%d3
	cmp.w #1,%d3
	jbhi .L590
	move.w #4,-(%sp)
	pea .LC159
	move.w #95,-(%sp)
	move.w #93,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	move.w #4,-(%sp)
	move.w x,%d0
	muls.w #14,%d0
	move.l 8(%a3,%d0.l),-(%sp)
	move.w #95,-(%sp)
	move.w #115,-(%sp)
	jbra .L627
	.even
.L590:
	move.w #4,-(%sp)
	pea .LC160
	move.w #95,-(%sp)
	move.w #93,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	move.w #4,-(%sp)
	move.w x,%d0
	muls.w #14,%d0
	move.l 8(%a3,%d0.l),-(%sp)
	move.w #95,-(%sp)
	move.w #127,-(%sp)
.L627:
	move.l 1700(%a5),%a0
	jsr (%a0)
	lea (20,%sp),%sp
.L586:
	cmp.w #-1,x.l
	jbne .L592
	move.w y,%d0
	cmp.w #5,%d0
	jbeq .L606
	add.w toolOffset,%d0
	cmp.w #6,%d0
	jbhi .L593
	and.l #0xFFFF,%d0
	add.l %d0,%d0
	.set .LI602,.+2
	move.w .L602-.LI602.b(%pc,%d0.l),%d0
	jmp %pc@(2,%d0:w)
	.even
.L602:
	.word .L595-.L602
	.word .L596-.L602
	.word .L598-.L602
	.word .L598-.L602
	.word .L599-.L602
	.word .L600-.L602
	.word .L601-.L602
	.even
.L595:
	pea .LC161
	jbra .L628
	.even
.L596:
	pea .LC144
	jbra .L628
	.even
.L598:
	pea .LC162
	jbra .L628
	.even
.L599:
	pea .LC163
	jbra .L628
	.even
.L600:
	pea .LC164
	jbra .L628
	.even
.L601:
	pea .LC165
.L628:
	pea -110(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	addq.l #8,%sp
.L593:
	move.w y,%d0
	cmp.w #5,%d0
	jbeq .L606
	add.w toolOffset,%d0
	cmp.w #16,%d0
	jbgt .L606
	cmp.w #6,%d0
	jbgt .L605
.L606:
	move.w y,%d1
	move.w %d1,%d0
	add.w toolOffset,%d0
	cmp.w #17,%d0
	jbne .L604
	cmp.w #5,%d1
	jbne .L604
.L605:
	pea .LC100
	moveq.l #-110,%d3
	add.l %a6,%d3
	move.l %d3,-(%sp)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.w y,%d0
	add.w toolOffset,%d0
	subq.w #7,%d0
	ext.l %d0
	lsl.l #2,%d0
	lea symbolName,%a0
	move.l (%a0,%d0.l),-(%sp)
	move.l %d3,-(%sp)
	move.l 2488(%a5),%a0
	jsr (%a0)
	lea (16,%sp),%sp
.L604:
	cmp.w #11,toolOffset.l
	jbgt .L607
	cmp.w #5,y.l
	jbne .L607
	pea .LC166
	pea -110(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	addq.l #8,%sp
.L607:
	tst.w toolOffset
	jbeq .L608
	tst.w y
	jbne .L608
	pea .LC167
	pea -110(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	addq.l #8,%sp
.L608:
	move.w #4,-(%sp)
	pea -110(%a6)
	move.w #95,-(%sp)
	move.w #1,-(%sp)
	move.l 1700(%a5),%a0
	jsr (%a0)
	lea (10,%sp),%sp
.L592:
	tst.w refreshMenu
	jbeq .L352
	move.w -114(%a6),-(%sp)
	move.l 224(%a5),%a0
	jsr (%a0)
	move.w -116(%a6),-(%sp)
	move.l 636(%a5),%a0
	jsr (%a0)
	clr.w -(%sp)
	clr.w -(%sp)
	clr.w -(%sp)
	move.w -116(%a6),-(%sp)
	move.l 612(%a5),%a0
	jsr (%a0)
	addq.l #2,%sp
	move.l %a0,-(%sp)
	move.l 216(%a5),%a0
	jsr (%a0)
	move.w %d0,-114(%a6)
	clr.w refreshMenu
	clr.w -(%sp)
	move.l 1596(%a5),%a0
	jsr (%a0)
	lea (16,%sp),%sp
.L352:
	cmp.w #16,%d7
	jbne .L354
	move.w -114(%a6),-(%sp)
	move.l 224(%a5),%a0
	jsr (%a0)
	move.w -116(%a6),-(%sp)
	move.l 636(%a5),%a0
	jsr (%a0)
	move.w -116(%a6),-(%sp)
	move.l 604(%a5),%a0
	jsr (%a0)
	move.l 292(%a5),%a0
	jsr (%a0)
	movm.l -152(%a6),#0x1cf8
	unlk %a6
	rts
	.even
.globl _main
_main:
#APP
	/* Support for OPTIMIZE_ROM_CALLS */
	move.l 0xC8,%a5
	/* Support for exit and atexit */
	bset #7,(%sp)
#NO_APP
	link.w %a6,#0
	move.l %a2,-(%sp)
	lea clrscr,%a2
	jsr (%a2)
	jbsr drawPLC
	move.w #75,watch
	move.w #117,watch+2
	move.w #97,watch+4
	move.w #115,watch+6
	subq.l #2,%sp
	move.b #111,1(%sp)
	subq.l #2,%sp
	move.b #105,1(%sp)
	subq.l #2,%sp
	move.b #104,1(%sp)
	jbsr flush
	move.l 324(%a5),%a0
	jsr (%a0)
	jsr (%a2)
	clr.w toolOffset
	clr.w winOffset
	move.w #-1,y
	move.w #-5,x
	jbsr refresh
	jbsr standby
	move.l -4(%a6),%a2
	unlk %a6
	rts
.comm _nostub,2
.comm _ti89,2
.comm _ti92plus,2
.globl ladder
	.even
ladder:
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.even
